{$ASMMODE INTEL}
{$APPTYPE GUI}
{$MODE FPC}
{$Q-}
{$R-}
{$S-}
{$D-}




// Visit http://www.venomsoftware.de

// CONTACT :  webmaster@venomsoftware.de      // website eMail
//            chtm@gmx.de                     // private eMail






{
  $Id: VGFX_Extra.pp, 2002/08/01 Christian Tobias Magnus

  Fast graphic unit for Free Pascal 32 Bit.
  Full compatible and tested on Win95/98/98SE/NT/ME/2000/XP

  This unit is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation;

  You are not allowed to use this unit for commercial purposes
  without the authors permission. Also you are not allowed to
  make modified version public without the authors permission.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  This unit is part of VGFX !

  Would be nice if you mention the author of this unit in your
  own releases to give him a little tribute... thanx !
}








UNIT VGFX_Extra;


INTERFACE



USES     VGFX;



{---------------------------------------------------------------------------}

 FUNCTION  CalculateLine      (x1,y1,x2,y2:LongInt):LongInt;
 FUNCTION  CalculateDetailLine(x1,y1,x2,y2:LongInt):LongInt;

{---------------------------------------------------------------------------}





IMPLEMENTATION


CONST   Copyright = 'Copyright (c) 2002 by Christian T. Magnus, Venom Software. All rights reserved.';




{---------------------------------------------------------------------------}


FUNCTION CalculateLine(x1,y1,x2,y2:LongInt):LongInt;
VAR       xDIFF,yDIFF,xADD,yADD,Rest : LongInt;
Begin
 CalculateLine:= 1;
 ASM
  Mov eax,x1
  Cmp eax,x2
  Jl  @Kleiner1
   Je @Ende1
   Mov xAdd,-1
   Jmp @Ende1
  @Kleiner1:
  Mov xAdd,1
  @Ende1:

  Mov eax,y1
  Cmp eax,y2
  Jl  @Kleiner2
   Je @Ende2
   Mov yAdd,-1
   Jmp @Ende2
  @Kleiner2:
  Mov yAdd,1
  @Ende2:
 END;
 xDIFF:= abs(x1-x2);
 yDIFF:= abs(y1-y2);
 If xDIFF>yDIFF then
 begin
  Rest:=-(xDIFF shr 1);
  WHILE x1<>x2 do
  begin
   Inc(Rest,yDIFF);
   Inc(x1,xADD);
   If Rest>0 then
   begin
    Inc(y1,yADD);
    Dec(Rest,xDIFF);
   end;
   Inc(CalculateLine);
  end;
 end
 else
 begin
  Rest:=-(yDIFF shr 1);
  WHILE y1<>y2 do
  begin
   Inc(Rest,xDIFF);
   Inc(y1,yADD);
   If Rest>0 then
   begin
    Inc(x1,xADD);
    Dec(Rest,yDIFF);
   end;
   Inc(CalculateLine);
  end;
 end;
End;


FUNCTION CalculateDetailLine(x1,y1,x2,y2:LongInt):LongInt;
VAR      xDIFF,yDIFF,xADD,yADD,Rest : LongInt;
Begin
 CalculateDetailLine:= 1;
 ASM
  Mov eax,x1
  Cmp eax,x2
  Jl  @Kleiner1
   Je @Ende1
   Mov xAdd,-1
   Jmp @Ende1
  @Kleiner1:
  Mov xAdd,1
  @Ende1:

  Mov eax,y1
  Cmp eax,y2
  Jl  @Kleiner2
   Je @Ende2
   Mov yAdd,-1
   Jmp @Ende2
  @Kleiner2:
  Mov yAdd,1
  @Ende2:
 END;
 xDIFF:= abs(x1-x2);
 yDIFF:= abs(y1-y2);
 If xDIFF>yDIFF then
 begin
  Rest:=-(xDIFF shr 1);
  WHILE x1<>x2 do
  begin
   Inc(Rest,yDIFF);
   Inc(x1,xADD);
   If Rest>0 then
   begin
    Inc(CalculateDetailLine);
    Inc(y1,yADD);
    Dec(Rest,xDIFF);
   end;
   Inc(CalculateDetailLine);
  end;
 end
 else
 begin
  Rest:=-(yDIFF shr 1);
  WHILE y1<>y2 do
  begin
   Inc(Rest,xDIFF);
   Inc(y1,yADD);
   If Rest>0 then
   begin
    Inc(CalculateDetailLine);
    Inc(x1,xADD);
    Dec(Rest,yDIFF);
   end;
   Inc(CalculateDetailLine);
  end;
 end;
End;


(******************************** INIT UNIT *********************************)


BEGIN

END.

