{$ASMMODE INTEL}
{$APPTYPE GUI}
{$MODE FPC}
{$Q-}
{$R-}
{$S-}
{$D-}

{

////////////////////////////////
////   SIMSON program 1.1   ////
////////////////////////////////
         FORRSKD



Ksztette: Vneki Balzs
Ennek a programnak a clja, hogy szemlltesse a hromszgre vonatkoz
nevezetes tteleket. Szval ez az brzol geometria fontos rsze.
Ha matekot tanulsz, vagy szereted a matematikt, akkor ne felejtsd el
kiprblni ezt az INGYENES programot!


Ez a SIMSON program 1.1-es verzijnak a forrskdja. A program
FreePascal-ban rdott. A grafikhoz felhasznltam a VENOM Software
VGFX grafikjt ( www.venomsoftware.de ). A program 800x600 felbontsban
dolgozik 16 bit sznnel.

A programnak a forrskdja azrt nyilvnos, hogy a kezd programozk
tanulhassanak belle. Igyekeztem minl tbb rszt a forrskdban
megjegyzsekkel rthetbb tenni.

Minden jog fenntartva. Jelen programot vagy annak rszeit a szerz engedlye
nlkl brmilyen formban vagy eszkzzel reproduklni tilos!
Ez azt jelenti, hogyha fel akarsz hasznlni valamilyen dolgot a programban
(pl. eljrs,fggvny,kp, stb.), akkor kteles vagy rtesteni engem
errl, s megbeszljk. A program ltal okozott esetleges krokrt
felelssget nem vllalok.

Elrhetsgeim:    E-mail:  bvoneki@buli.net
                   Posta:   6728 Szeged, Tlgyfa utca 20.
                   Tel:     06-62-473-231
                   Mobil:   06-30-374-274-0





}

program simson_program ;

uses    windows,
        vgfx,
        vgfx_2d,
        vgfx_sprites,
        vgfx_text,
        vgfx_win32,
        vgfx_files,
        vgfx_errors,
        bigfile2,
        sysutils,
        math;

// a program RADIANban dolgozik



const   ApplicationID        : PChar = 'SIMSON egyenes'; // a program ablaknak a neve

        Width                : Longint = 800; // felbonts szlessge (pixelekben)
        Height               : Longint = 600; // felbonts magassga  (pixelekben)
        szerkesztx=800;
        szerkeszty=458;

        gombokszama=20;

        pontok_szama=   60;
        szakaszok_szama=50;
        egyenesek_szama=50;
        korok_szama=    10;
        parabolak_szama=3;

        ketpi=  6.2831853071795864769;  // matematikai llandk, amelyek
        pi=     3.1415926535897932385;  // gyakran elkerlnek a klnbz
        piper2= 1.5707963267948966192;  // matematikai szmtsokban

        arnyekR=25; // minden geometriai elemnek van rnyka, s ez hatrozza
        arnyekG=50; // meg a sznt
        arnyekB=25;

        arnyektolX=3; // ez megadja, hogy a geometriai elem helyhez kpest
        arnyektolY=3; // mennyivel legyen eltolva az rnyk (pixelekben)


        bazispont1x=300; // a hromszg kezdeti pozcii (helyei)
        bazispont1y=400;
        bazispont2x=550;
        bazispont2y=405;
        bazispont3x=420;
        bazispont3y=150;

        //simson lland(k)
        Snevezoallando=2000000000;

        //parabolk
        pa_intervallum=200; // a program a parabolnak csak egy bizonyos
                            // rszt rajzolja ki, s nem az egszet,
                            // (az egszet nem is tudn, hiszen vgtelen
                            // hossz, s az vgtelen sok ideig tartana)
                            // hanem csak egy bizonyos intervallumban,
                            // ez konstans teht az intervallum nagysgt
                            // hatrozza meg

        pa_suruseg=10; // a parabola vonalakbl pl fel, s ez adja, meg,
                       // hogy milyen srn legyenek a vonalak (teht ez
                       // hatrozza meg a parabola megjelensi "minsgt")


type    pont_type=record    kx,ky,meret:longint;
                       red,green,blue:byte;
                 //      nev:string;nevkor:boolean;
                       x,y:real;
                       aktiv,letezes:boolean;end;
                      //aktiv: ez szabalyozza, hogy ki legyen-e rajzolva
                      //letezes: ez pedig, hogy letre tud-e jnni az objektum
                      //         ha nem, akkor nem tud vele szamolni!

        szakasz_type=record x1,y1,x2,y2,szog:real; // vals hely
                       kx1,ky1,kx2,ky2:longint; // kerektett -> kirajzolsra
                       red,green,blue:byte;
                       meret:word;
                       //a,b,c,d,szog:real; // y=ax+b x=cy+d irnyszg
                       aktiv,letezes:boolean;end;
        egyenes_type=record a,b,c,d,szog:real;
                       red,green,blue:byte;
                       x1,y1,x2,y2:longint; //kirajzolshoz szksges
                                            //paramter, s ezrt egsz
                                            //a tbbiekkel szemben
                       meret:word;
                       aktiv,letezes,ab,cd:boolean;end;
        kor_type=record     x,y,r:real; // r=sugr
                       red,green,blue:byte;
                       kx,ky,kr,meret:longint; //meret=vastagsg
                       aktiv,letezes:boolean;end;
        parabola_type=record  x,y,tx,ty:real;
                              a,b,c,d,szog,parameter:real;
                              red,green,blue,meret:byte;
                              aktiv,letezes,ab,cd:boolean;
                      end;



        mt_type=array[2..10] of record
                                 pont:array[1..pontok_szama] of record
                                 meret,r,g,b:byte;aktiv:boolean; end;

                                 szakasz:array[1..szakaszok_szama] of record
                                 meret,r,g,b:byte;aktiv:boolean; end;

                                 egyenes:array[1..egyenesek_szama] of record
                                 meret,r,g,b:byte;aktiv:boolean; end;

                                 kor:array[1..korok_szama] of record
                                 meret,r,g,b:byte;aktiv:boolean; end;

                                 parabola:array[1..parabolak_szama] of record
                                 meret,r,g,b:byte;aktiv:boolean;end;
                                end;





var     Sprite01,ures,BackGround,Result,
        kek,sarga,szurke,gombkeret : VirtualWindow;
        //a gombkeret az a kp, amit pl. kkkel tltk ki, hogy aztn
        //alfablending-gel rrakjam a httrmenre!

        rgbtocol:array[0..31,0..63,0..31] of word;

        i,j:longint;

        gomb:array[1..gombokszama] of record
        x1,y1,x2,y2:word;
        szurke:boolean; //szurke=inaktiv

        {megjegyzes:boolean;
        megjegyzeskep:virtualwindow;}
        end;

        hulyesegboolean:boolean; //olyan vltoz, aminek lenyegtelen az
                                 //ertelme, mert csak az eljrsok (olykor)
                                 //szksgtelen paramtereit ki kell vele
                                 //tlteni

        sargamenu:byte; // annak a gombnak a szma, amelyik SARGA





        //rtke, hogy az elozo ciklusban le volt-e nyomva az egr bal gombja
        m_ltomb:array[1..5] of boolean;
        mozgat: boolean;
        melyikmozgat:byte;


        //ez a tmb trolja, hogy az egyes menpontoknl mik legyenek
        //lthatk, milyen mretben s sznben
        //  mt=menutomb ( =megjelenestomb)
        mt:mt_type;

        sugob,sfirst:boolean;
        fenyforras:shortint; // (-31) - (+31)


        {a SIMSON vltozi}

        simson_szog:real;  //aktulis szg
        sebesseg: byte;  // a simson-egyenes pontjnak mozgsi gyorsasga
                         // rtke 0-85 kztt vltakozhat (ez az idelis, amit a pilseb el fog rni)
        animacio:boolean;  //ha a krbenyl, akkor animacio=TRUE
                           //ha kz, akkor animacio=FALSE
        pilseb: real; // a pillanatnyi sebessg, a vals    rtkkszlet: 0-85
        play: boolean;
        mp:longint; //1 mp alatt hnyig szmol el a gp
        gyorsitas,kiegyenlito:real;
        {kiegyenlito: "kiegyenlti" a simson_szog kepezesnel a kifejezs rtkt,
                       nehogy bazinaggyal nvelje (MP-tol fggo rtk)}


        {a GEOMETRIAI elemek tmbjei}

        Pont:     array[1..pontok_szama] of pont_type;
        Szakasz:  array[1..szakaszok_szama] of szakasz_type;
        Egyenes:  array[1..egyenesek_szama] of egyenes_type;
        Kor:      array[1..korok_szama] of kor_type;
        Parabola: array[1..parabolak_szama] of parabola_type;
{
PONT:   1: a 3szg A pontja      <-- bzispontok
        2: a 3szg B pontja
        3: a 3szg C pontja

        4: -//- AB szakasz felezoje
        5: -//- BC szakasz felezoje
        6: -//- CA szakasz felezoje

        7: -//- C talppontja AB-n  Tc
        8: -//- A talppontja BC-n  Ta
        9: -//- B talppontja CA-n  Tb

       10: az A cscshoz tartoz hozzrt kr kp.-ja
       11: a B cscshoz tartoz hozzrt kr kp.-ja
       12: a C cscshoz tartoz hozzrt kr kp.-ja

       13: krrt kr kp.-ja
       14: bert kr kp.-ja
       15: magassgpont
       16: slypont

       17: simson Pont
       18: a S.pont AB-re talppontja
       19: a S.pont BC-re talppontja
       20: a S.pont CA-ra talppontja

       21: a bert kr kp.-ja az AB-re vettett talppontja    Lthatatlanok!
       22: az A-hoz tartoz hozzrt kr kp.-ja az AB-re talppontja
       23: a B-hez tartoz hozzrt kr kp.-ja az AB-re talppontja
       24: a C-hez tartoz hozzrt kr kp.-ja az AB-re talppontja

       25: C-bol indulo belso szgfelezo AB-vel valo metszespontja  Lthatatlanok!
       26: A-bol indulo belso szgfelezo BC-vel valo metszespontja
       27: B-bol indulo belso szgfelezo CA-vel valo metszespontja


SZAKASZ:  1: AB szakasz
          2: BC szakasz
          3: CA szakasz

          4: AB-n tmeno slyvonal
          5: BC-n tmeno slyvonal
          6: CA-n tmeno slyvonal

          7: AB-n tmeno magassg
          8: BC-n tmeno magassg
          9: CA-n tmeno magassg

         10: C-bol indulo belso szgfelezo szakasz
         11: A-bol indulo belso szgfelezo szakasz
         12: B-bol indulo belso szgfelezo szakasz

         13: talpponti 3szg  TcTa
         14: talpponti 3szg  TaTb
         15: talpponti 3szg  TbTc

EGYENES:  1: AB oldalegyenese
          2: BC oldalegyenese
          3: CA oldalegyenese

          4: AB-n tmeno slyvonalegyenes  Lthatatlanok!
          5: BC-n tmeno slyvonalegyenes
          6: CA-n tmeno slyvonalegyenes

          7: AB-n tmeno magassgegyenes
          8: BC-n tmeno magassgegyenes
          9: CA-n tmeno magassgegyenes

         10: AB oldalfelezo merolegese
         11: BC oldalfelezo merolegese
         12: CA oldalfelezo merolegese

         13: AB-n tmeno belso szgfelezo
         14: BC-n tmeno belso szgfelezo
         15: CA-n tmeno belso szgfelezo

         16: C-n tmeno klso szgfelezo
         17: A-n tmeno klso szgfelezo
         18: B-n tmeno klso szgfelezo

         19: Euler-egyenes
         20: Simson-egyenes

KR:     1: krrt kr
         2: bert kr

         3: A-hoz tartoz hozzrt kr
         4: B-hez tartoz hozzrt kr
         5: C-hez tartoz hozzrt kr

PARABOLA: 1: C fkusz parabola
          2: A fkusz parabola
          3: B fkusz parabola

}




function paros(szam:word):boolean;
begin
if szam mod 2=0 then paros:=true else paros:=false;
end;




function booleankepzo(b:boolean):string;
begin
if b then booleankepzo:='T'
     else booleankepzo:='F';
end;



//a fggvny nem engedi meg, hogy a belrt szm negatvknt trjen vissza
{friss megjegyzs: a korkirak-nal volt, de nagyon lelasstotta a programot,
                   kiszedtem s gy ltszik, hogy enlkl is mukodik!}
function nemnegativ(szam:longint):longint;
begin
if szam<0 then szam:=0;
end;





// olyan fggvny, amely TRUE ha az egr rajta van az adott gombon
function gombonvan(gombszam:byte):boolean;
begin
if (gomb[gombszam].x1<=m_x) and (m_x<=gomb[gombszam].x2 ) and
   (gomb[gombszam].y1<=m_y) and (m_y<=gomb[gombszam].y2) then
   gombonvan:=true else gombonvan:=false;
end;






//olyan fggvny, amely TRUE ha az egr rajta van s kattint
function gombkattint(gombszam:byte):boolean;
begin
if (gombonvan(gombszam)) and (m_l) and (not m_ltomb[2])
   then gombkattint:=true
   else gombkattint:=false;
end;





//kirajzolja az elore megadott helyre egy gombot (a zrjelben megadhat a gomb szma)
procedure gombkirak(gombszam:byte);
var
k:byte;
begin
//kk raks
if (gombonvan(gombszam)) and not ( (gombszam>=12) and (gombszam<=16) and (sargamenu<>9) ) then begin
if gombszam<>16 then
init_vw(gombkeret,gomb[gombszam].x2-gomb[gombszam].x1,gomb[gombszam].y2-gomb[gombszam].y1,true)
else
init_vw(gombkeret,gomb[gombszam].x2-gomb[gombszam].x1,gomb[gombszam].y2-m_y+2,true);

scalesprite(kek,gombkeret);

if gombszam<>16 then
puttranssprite(result,gombkeret,gomb[gombszam].x1,gomb[gombszam].y1,5,10,5)
else
puttranssprite(result,gombkeret,gomb[gombszam].x1,m_y-2,10,20,10);

kill_vw(gombkeret);
end;

//srga raks
if (gombkattint(gombszam)) and (gombszam>=2) and
   (gombszam<=10) then sargamenu:=gombszam;

if (sargamenu=gombszam) or ((16=gombszam) and (sargamenu=9)) then begin
if gombszam<>16 then
init_vw(gombkeret,gomb[gombszam].x2-gomb[gombszam].x1,gomb[gombszam].y2-gomb[gombszam].y1,true)
else
init_vw(gombkeret,gomb[gombszam].x2-gomb[gombszam].x1,sebesseg+2,true);

scalesprite(sarga,gombkeret);

if gombszam<>16 then
puttranssprite(result,gombkeret,gomb[gombszam].x1,gomb[gombszam].y1,18,36,18)
else
begin
if not gombonvan(16) then
puttranssprite(result,gombkeret,gomb[gombszam].x1,gomb[16].y2-sebesseg-2,25,50,25)
else
puttranssprite(result,gombkeret,gomb[gombszam].x1,gomb[16].y2-sebesseg-2,15,30,15);
end;


kill_vw(gombkeret);
end;

//szrke raks
if sargamenu=9 then for k:=12 to 16 do gomb[k].szurke:=false
               else for k:=12 to 16 do gomb[k].szurke:=true;


if gomb[gombszam].szurke then begin
if gombszam<>16 then
init_vw(gombkeret,gomb[gombszam].x2-gomb[gombszam].x1,gomb[gombszam].y2-gomb[gombszam].y1,true)
else
init_vw(gombkeret,gomb[gombszam].x2-gomb[gombszam].x1,sebesseg+2,true);

scalesprite(szurke,gombkeret);

if gombszam<>16 then
puttranssprite(result,gombkeret,gomb[gombszam].x1,gomb[gombszam].y1,20,40,20)
else
puttranssprite(result,gombkeret,gomb[gombszam].x1,gomb[16].y2-sebesseg-2,20,40,20);

kill_vw(gombkeret);
end;

end;







//feltlti az rgbtocol nevu tmbt a megfelelo rtkekkel
procedure fill_rgbtocolor;
var
ideiglenes:virtualwindow;
re,gr,bl:byte;

begin

for re:=0 to 31 do for gr:=0 to 63 do for bl:=0 to 31 do
      begin
      init_vw(ideiglenes,2,2,false);
      putpixel(ideiglenes,1,1,re,gr,bl);
      rgbtocol[re,gr,bl]:=getpackedpixel(ideiglenes,1,1);
      kill_vw(ideiglenes);
      end;
end;






procedure lineclippedhorz(ablak:virtualwindow;x1,x2,y:longint;r,g,b:byte);
var
i:longint;
begin

 if x1<x2 then for i:=x1 to x2 do putclippedpixel(ablak,i,y,r,g,b)
          else for i:=x1 downto x2 do putclippedpixel(ablak,i,y,r,g,b)
end;






procedure fullclippedcircle(dest:virtualwindow;x0,y0,radius:longint;
                            r,g,b:byte);
var
x,y,p:longint;
begin
 x:=0;
 y:=-radius;
 p:=y shl 1+3;
 while x<=-y do begin
  lineclippedhorz(dest,x0-x,x0+x,y0+y,r,g,b);
  lineclippedhorz(dest,x0-x,x0+x,y0-y,r,g,b);
  lineclippedhorz(dest,x0-y,x0+y,y0+x,r,g,b);
  lineclippedhorz(dest,x0-y,x0+y,y0-x,r,g,b);
  if p>=0 then
  begin
   inc(y);
   inc(p,(x+y) shl 2+6);
  end else inc(p,x shl 2+6);
  inc(x);
 end;

end;






//vastag vonal
procedure lineclippedbold(ablak:virtualwindow;
                          x1,y1,x2,y2:longint;meret,r,g,b:byte);
var
tav,ii,aa,bb:longint;
arany:real;

begin
{     1
    2
}

aa:=x2-x1;
bb:=y2-y1;

tav:=round( sqrt(  sqr(aa) + sqr(bb)   ) );

 for ii:=1 to tav do
 begin
 arany:=ii/tav;
 fullclippedcircle(ablak, x1+round(aa*arany) , y1+round(bb*arany) ,meret-1,r,g,b);
 end;

end;






//// A SZERKESZTS ELJARASAI




// ez az eljrs kt adott pont ltal meghatrozott egyenes
// egyenletvel tr vissza
procedure ketpont_egyenesenek_abcdszog(x1,y1,x2,y2:real;
                                       var a,b,c,d,szog:real;
                                       var ab,cd:boolean);
begin

 if not ((x1=x2) and (y1=y2)) then begin

   if x1<>x2 then begin
   // y=ax+b x=cy+d
   a:=(y2-y1)/(x2-x1);
   b:=(x2*y1-x1*y2)/(x2-x1);
   ab:=true;
   szog:=arctan(a);

     if y1<>y2 then begin
     c:=1/a;
     d:=-(b/a);
     cd:=true;
     end
     else cd:=false;
   end;

   if x1=x2 then begin
   ab:=false;
   cd:=true;
   c:=0;
   d:=x1;
   szog:=piper2;
   end;

 end;
end;






// ez az eljrs meghatrozza kt adott egyenes metszspontjt
// (mr ha egyltaln van ilyen, mert nem felttlenl metszik el
// egymst, mghozz akkor nem, ha prhuzamosak)
procedure ketegyenes_metszespontja(a1,b1,c1,d1,
                                   a2,b2,c2,d2 :real;
                                   ab1,cd1,ab2,cd2:boolean;
                                   var x,y:real;
                                   var letezes:boolean);
var
szog1,szog2:real;
begin
if ab1 then szog1:=arctan(a1) else szog1:=piper2;
if ab2 then szog2:=arctan(a2) else szog2:=piper2;

  //ha nem prhuzamosak
 if szog1<>szog2 then
 begin
 letezes:=true;

   if (ab1) and (ab2) then
   begin
   x:=(b2-b1)/(a1-a2);
   y:=a1*x+b1;
   end;

   if (ab1) and (cd1=false) and (ab2=false) and (cd2=true) then
   begin
   x:=d2;
   y:=a1*x+b1;
   end;

   if (ab1=false) and (cd1) and (ab2) and (cd2=false) then
   begin
   x:=d1;
   y:=a2*x+b2;
   end;

 end
 else letezes:=false;

end;






// bemen adatknt meg kell adnod egy egyenest s egy pontot, s
// az eljrs visszatr egy olyan egyenes egyenletvel, ami tmegy
// az adott ponton, s emellett merleges az eredeti egyenesre
procedure pontonatmeno_egyenesre_meroleges(a,b,c,d:real;ab,cd:boolean;
                                           x,y:real;
                                           var a2,b2,c2,d2,szog2:real;
                                           var ab2,cd2:boolean);
var
szog:real;
begin
if ab then szog:=arctan(a) else szog:=piper2;

  if (ab) and (cd) then
  begin
  a2:=tan(szog+piper2);
  b2:=y-a2*x;
  c2:=1/a2;
  d2:=-(b2/a2);
  ab2:=true;cd2:=true;
  szog2:=szog+piper2;
  if szog2>pi then szog2:=szog2-pi;
  end;

  if (ab) and (cd=false) then
  begin
  ab2:=false;cd2:=true;
  c2:=0;
  d2:=x;
  szog2:=piper2;
  end;

  if (ab=false) and (cd) then
  begin
  ab2:=true;cd2:=false;
  a2:=0;
  b2:=y;
  szog2:=0;
  end;

end;





// bemen adatknt meg kell adnot kt pontot, s az eljrs kiszmolja
// a kt pont ltal meghatrozott szakasznak a felezpontjt
procedure szakaszfelezo(x1,y1,x2,y2:real;var x3,y3:real);
begin
x3:=(x1+x2)/2;
y3:=(y1+y2)/2;
end;





// ha megadsz egy egyenest s egy pontot, akkor ez az eljrs levetti
// a pontot az egyenesre (kpzeletben), s a keletkezett talppontnak a
// koordintival tr vissza
procedure pontnak_egyenesre_talppontja(a,b,c,d:real;ab,cd:boolean;
                                       x,y:real;
                                       var xt,yt:real);
var
a2,b2,c2,d2,szog2:real; // a meroleges egyenes paramterei
ab2,cd2:boolean;
begin

pontonatmeno_egyenesre_meroleges(a,b,c,d,ab,cd,x,y,a2,b2,c2,d2,szog2,ab2,cd2);
ketegyenes_metszespontja(a,b,c,d,a2,b2,c2,d2,ab,cd,ab2,cd2,xt,yt,hulyesegboolean);

end;






// ez a szgfelez kiszmolshoz szksges
procedure harompontra_szogfelezo(x1,y1,x2,y2,x3,y3:real;
                                  var a,b,c,d,szog:real;
                                  var ab,cd:boolean);
var
xo,yo:real; //az osztpont az 1 s 3 pont kztt
a1,b1,c1,d1,szog1,a2,b2,c2,d2,szog2:real;
ab1,cd1,ab2,cd2:boolean;
tav12,tav23:real;

begin
{   1    |            <-- a pontok elhelyezkedse, s kzpen a
         /   3              szgfelezo lthat
        /
        |
        2        }

{A program a szgfelezo tetelt felhasznalva megkeresi azt az osztpontot
 az 1 s 3 pontok kztt, hogy ennek a pontnak a tvolsga az 1 s 3
 pontoktl arnyos legyen az 1;2 s 2;3 pontok tvolsgval.}


if not (((x1=x2) and (y1=y2)) or ((x2=x3) and (y2=y3)) or
       ((x3=x1) and (y3=y1))) then
   begin

    ketpont_egyenesenek_abcdszog(x1,y1,x2,y2, a1,b1,c1,d1,szog1,ab1,cd1);
    ketpont_egyenesenek_abcdszog(x2,y2,x3,y3, a2,b2,c2,d2,szog2,ab2,cd2);
     if szog1<>szog2 then
     begin

     tav12:=sqrt( sqr(x1-x2) + sqr(y1-y2) );
     tav23:=sqrt( sqr(x2-x3) + sqr(y2-y3) );

     xo:=(tav23*x1+tav12*x3)/(tav12+tav23); // az osztpont koordinti
     yo:=(tav23*y1+tav12*y3)/(tav12+tav23);

     ketpont_egyenesenek_abcdszog(x2,y2,xo,yo,
                                  a,b,c,d,szog,ab,cd);
     end;

   end
   else begin ab:=false;cd:=false;end;

end;







procedure pont_szamol(pontszam:byte);
begin
if pont[pontszam].letezes then begin
//kerekts
pont[pontszam].kx:=round(pont[pontszam].x);
pont[pontszam].ky:=round(pont[pontszam].y);
end;
end;




procedure szakasz_szamol(szakaszszam:byte);
begin

if szakasz[szakaszszam].letezes then begin
//kerekts
szakasz[szakaszszam].kx1:=round(szakasz[szakaszszam].x1);
szakasz[szakaszszam].ky1:=round(szakasz[szakaszszam].y1);
szakasz[szakaszszam].kx2:=round(szakasz[szakaszszam].x2);
szakasz[szakaszszam].ky2:=round(szakasz[szakaszszam].y2);

if (szakasz[szakaszszam].kx1=szakasz[szakaszszam].kx2) and
   (szakasz[szakaszszam].ky1=szakasz[szakaszszam].ky2) then
   szakasz[szakaszszam].letezes:=false;

//szgszmols
  if szakasz[szakaszszam].letezes then
   if szakasz[szakaszszam].x1<>szakasz[szakaszszam].x2 then
   szakasz[szakaszszam].szog:=arctan((szakasz[szakaszszam].y2-
                            szakasz[szakaszszam].y1)/
                            (szakasz[szakaszszam].x2-
                            szakasz[szakaszszam].x1))
   else szakasz[szakaszszam].szog:=piper2;

end;
end;






procedure egyenes_szamol(egyenesszam:byte);
var
px1,py1,px2,py2:real;
begin

//szgszmols
 if (egyenes[egyenesszam].ab) and (egyenes[egyenesszam].cd) then
 egyenes[egyenesszam].szog:=arctan(egyenes[egyenesszam].a);

 if (egyenes[egyenesszam].ab) and (egyenes[egyenesszam].cd=false) then
 egyenes[egyenesszam].szog:=0;

 if (egyenes[egyenesszam].ab=false) and (egyenes[egyenesszam].cd) then
 egyenes[egyenesszam].szog:=piper2;

//kirajzolshoz szksges x1,y1,x2,y2 kiszmolsa

  {I. ha az egyenes "45 foknl laposabb" =>
   a kpernyo oldalso fggoleges egyeneseinek metszsvizsglata}
  if (egyenes[egyenesszam].ab) and (abs(egyenes[egyenesszam].a)<1) then
  begin
  {ketegyenes_metszespontja(egyenes[egyenesszam].a,egyenes[egyenesszam].b,
                           egyenes[egyenesszam].c,egyenes[egyenesszam].d,
                           1,1,0,0,
                           egyenes[egyenesszam].ab,egyenes[egyenesszam].cd,
                           false,true,px1,py1,hulyesegboolean);
  ketegyenes_metszespontja(egyenes[egyenesszam].a,egyenes[egyenesszam].b,
                           egyenes[egyenesszam].c,egyenes[egyenesszam].d,
                           1,1,0,800,
                           egyenes[egyenesszam].ab,egyenes[egyenesszam].cd,
                           false,true,px2,py2,hulyesegboolean);

  egyenes[egyenesszam].x1:=round(px1);
  egyenes[egyenesszam].y1:=round(py1);
  egyenes[egyenesszam].x2:=round(px2);
  egyenes[egyenesszam].y1:=round(py2);}

  egyenes[egyenesszam].x1:=0;
  egyenes[egyenesszam].y1:=round(egyenes[egyenesszam].b);
  egyenes[egyenesszam].x2:=szerkesztx;
  egyenes[egyenesszam].y2:=round(egyenes[egyenesszam].a*egyenes[egyenesszam].x2+egyenes[egyenesszam].b);


  end

  {II. ha az egyenes "meredekebb 45 foknl" =>
   a kpernyo also s felso vizszintes egyeneseinek metszst vizsglja}
  else begin
  //a lathat helyeken azrt van RANDOMSZM, hogy minl jobban szemll-
  //tessem, hogy ezeknek az lland egyeneseknek lenyegtelen azok
  //koordinti (a randomoknak), ugyanis nem lehet kifejezni azon a mdon

  {ketegyenes_metszespontja(egyenes[egyenesszam].a,egyenes[egyenesszam].b,
                           egyenes[egyenesszam].c,egyenes[egyenesszam].d,
                           0,0,1,1,
                           egyenes[egyenesszam].ab,egyenes[egyenesszam].cd,
                           true,false,px1,py1,hulyesegboolean);
  ketegyenes_metszespontja(egyenes[egyenesszam].a,egyenes[egyenesszam].b,
                           egyenes[egyenesszam].c,egyenes[egyenesszam].d,
                           0,500,1,1,
                           egyenes[egyenesszam].ab,egyenes[egyenesszam].cd,
                           true,false,px2,py2,hulyesegboolean);

  egyenes[egyenesszam].x1:=round(px1);
  egyenes[egyenesszam].y1:=round(py1);
  egyenes[egyenesszam].x2:=round(px2);
  egyenes[egyenesszam].y1:=round(py2);}

  egyenes[egyenesszam].y1:=0;
  egyenes[egyenesszam].x1:=round(egyenes[egyenesszam].d);
  egyenes[egyenesszam].y2:=szerkeszty+2;
  egyenes[egyenesszam].x2:=round(egyenes[egyenesszam].c*egyenes[egyenesszam].y2+egyenes[egyenesszam].d);


  end;
end;





procedure kor_szamol(korszam:byte);
begin
//kerekts
kor[korszam].kx:=round(kor[korszam].x);
kor[korszam].ky:=round(kor[korszam].y);
kor[korszam].kr:=round(kor[korszam].r);
end;




// kirajzol a kpernyre egy pontot
procedure pontkirak(pontszam:byte);
begin

 if (pont[pontszam].aktiv) and (pont[pontszam].letezes) then
 begin
 pont_szamol(pontszam);
 fullclippedcircle(sprite01,pont[pontszam].kx,pont[pontszam].ky,
 pont[pontszam].meret,pont[pontszam].red,pont[pontszam].green,
 pont[pontszam].blue);
 end;
end;




// kirajzol a kpernyre egy pontnak az rnykt
procedure pontarnyekkirak(pontszam:byte);
begin

 if (pont[pontszam].aktiv) and (pont[pontszam].letezes) then
 begin
 pont_szamol(pontszam);
 fullclippedcircle(sprite01,pont[pontszam].kx+arnyektolX,
 pont[pontszam].ky+arnyektolY,pont[pontszam].meret,arnyekR,arnyekG,arnyekB);
 end;

end;





// kirajzol a kpernyre egy szakaszt
procedure szakaszkirak(szakaszszam:byte);
var
x1,y1,x2,y2:longint;
szog,szinusz,koszinusz:real;
piros,zold,kek,k:byte;

begin

 if (szakasz[szakaszszam].aktiv) and (szakasz[szakaszszam].letezes) then
 begin
 szakasz_szamol(szakaszszam);

 x1:=szakasz[szakaszszam].kx1; //azrt rtm t oket ebbe a vltozkba,
 y1:=szakasz[szakaszszam].ky1; //hogy kevesebbet kelljen rni annak
 x2:=szakasz[szakaszszam].kx2; //rdekben, hogy tlthatbb legyen a
 y2:=szakasz[szakaszszam].ky2; //program!
 szog:=szakasz[szakaszszam].szog+piper2;
 szinusz:=sin(szog); //azrt szmoltam ki ennek a meroleges szgnek a
 koszinusz:=cos(szog);//szinusz & koszinuszt, mert sokszor kell hasznlni
                      //s gyorstja az eljrst

 piros:=szakasz[szakaszszam].red;
 zold:=szakasz[szakaszszam].green;
 kek:=szakasz[szakaszszam].blue;

 if szakasz[szakaszszam].meret=1 then lineclipped(sprite01,x1,y1,x2,y2,
                                                  rgbtocol[piros,zold,kek])
                                 else lineclippedbold(sprite01,x1,y1,x2,y2,
                                                  szakasz[szakaszszam].meret,
                                                      piros,zold,kek);


 {lineclipped(sprite01,x1,y1,x2,y2,rgbtocol[piros,zold,kek]);

   if szakasz[szakaszszam].meret>1 then
   begin

   for k:=1 to szakasz[szakaszszam].meret-1 do
   if not paros(k) then
   lineclipped(sprite01,round(x1+((k div 2)+1)*koszinusz),
               round(y1+((k div 2)+1)*szinusz),
               round(x2+((k div 2)+1)*koszinusz),
               round(y2+((k div 2)+1)*szinusz),
               rgbtocol[piros,zold,kek])
                   else
   lineclipped(sprite01,round(x1-(k div 2)*koszinusz),
               round(y1-(k div 2)*szinusz),
               round(x2-(k div 2)*koszinusz),
               round(y2-(k div 2)*szinusz),
               rgbtocol[piros,zold,kek]);
   end;
  }


  end;

end;





// kirajzol a kpernyre egy szakasznak az rnykt
procedure szakaszarnyekkirak(szakaszszam:byte);
var
x1,y1,x2,y2:longint;
szog,szinusz,koszinusz:real;
piros,zold,kek,k:byte;

begin

 if (szakasz[szakaszszam].aktiv) and (szakasz[szakaszszam].letezes) then
 begin
 szakasz_szamol(szakaszszam);

 x1:=szakasz[szakaszszam].kx1; //azrt rtm t oket ebbe a vltozkba,
 y1:=szakasz[szakaszszam].ky1; //hogy kevesebbet kelljen rni annak
 x2:=szakasz[szakaszszam].kx2; //rdekben, hogy tlthatbb legyen a
 y2:=szakasz[szakaszszam].ky2; //program!
 szog:=szakasz[szakaszszam].szog+piper2;
 szinusz:=sin(szog); //azrt szmoltam ki ennek a meroleges szgnek a
 koszinusz:=cos(szog);//szinusz & koszinuszt, mert sokszor kell hasznlni
                      //s gyorstja az eljrst

 piros:=szakasz[szakaszszam].red;
 zold:=szakasz[szakaszszam].green;
 kek:=szakasz[szakaszszam].blue;

 if szakasz[szakaszszam].meret=1 then lineclipped(sprite01,x1+arnyektolX,
                                                  y1+arnyektolY,x2+arnyektolX,
                                                  y2+arnyektolY,
                                                  rgbtocol[arnyekR,arnyekG,
                                                  arnyekB])
                                 else lineclippedbold(sprite01,x1+arnyektolX,
                                                      y1+arnyektolY,
                                                      x2+arnyektolX,
                                                      y2+arnyektolY,
                                                  szakasz[szakaszszam].meret,
                                                  arnyekR,arnyekG,arnyekB);

 {lineclipped(sprite01,x1+arnyektolX,y1+arnyektolY,x2+arnyektolX,
             y2+arnyektolY,rgbtocol[arnyekR,arnyekG,arnyekB]);

   if szakasz[szakaszszam].meret>1 then
   begin

   for k:=1 to szakasz[szakaszszam].meret-1 do
   if not paros(k) then
   lineclipped(sprite01,round(x1+((k div 2)+1)*koszinusz)+arnyektolX,
               round(y1+((k div 2)+1)*szinusz)+arnyektolY,
               round(x2+((k div 2)+1)*koszinusz)+arnyektolX,
               round(y2+((k div 2)+1)*szinusz)+arnyektolY,
               rgbtocol[arnyekR,arnyekG,arnyekB])
                   else
   lineclipped(sprite01,round(x1-(k div 2)*koszinusz)+arnyektolX,
               round(y1-(k div 2)*szinusz)+arnyektolY,
               round(x2-(k div 2)*koszinusz)+arnyektolX,
               round(y2-(k div 2)*szinusz)+arnyektolY,
               rgbtocol[arnyekR,arnyekG,arnyekB]);

   end;
  }

 end;

end;






// kirajzol a kpernyre egy egyenest
procedure egyeneskirak(egyenesszam:byte);
var
x1,y1,x2,y2:longint;
szog,szinusz,koszinusz:real;
piros,zold,kek,k:byte;

begin

 if (egyenes[egyenesszam].aktiv) and (egyenes[egyenesszam].letezes) then
 begin
 egyenes_szamol(egyenesszam);

 x1:=egyenes[egyenesszam].x1;//hogy mirt rtam ki a vltozkat egy msikba:
 y1:=egyenes[egyenesszam].y1;//lsd a szakaszkirak-nl!
 x2:=egyenes[egyenesszam].x2;//ott is pontosan ugyanez van
 y2:=egyenes[egyenesszam].y2;
 szog:=egyenes[egyenesszam].szog+piper2;
 szinusz:=sin(szog);
 koszinusz:=cos(szog);

 piros:=egyenes[egyenesszam].red;
 zold:=egyenes[egyenesszam].green;
 kek:=egyenes[egyenesszam].blue;

 if egyenes[egyenesszam].meret=1
 then lineclipped(sprite01,x1,y1,x2,y2,rgbtocol[piros,zold,kek])
 else lineclippedbold(sprite01,x1,y1,x2,y2,egyenes[egyenesszam].meret,
                      piros,zold,kek);



 {lineclipped(sprite01,x1,y1,x2,y2,rgbtocol[piros,zold,kek]);

   if egyenes[egyenesszam].meret>1 then
   begin

   for k:=1 to egyenes[egyenesszam].meret-1 do
   if not paros(k) then
   lineclipped(sprite01,round(x1+((k div 2)+1)*koszinusz),
               round(y1+((k div 2)+1)*szinusz),
               round(x2+((k div 2)+1)*koszinusz),
               round(y2+((k div 2)+1)*szinusz),
               rgbtocol[piros,zold,kek])
                   else
   lineclipped(sprite01,round(x1-(k div 2)*koszinusz),
               round(y1-(k div 2)*szinusz),
               round(x2-(k div 2)*koszinusz),
               round(y2-(k div 2)*szinusz),
               rgbtocol[piros,zold,kek]);
   end;
  }
 end;

end;






// kirajzol a kpernyre egy egyenesnek az rnykt
procedure egyenesarnyekkirak(egyenesszam:byte);
var
x1,y1,x2,y2:longint;
szog,szinusz,koszinusz:real;
piros,zold,kek,k:byte;

begin

 if (egyenes[egyenesszam].aktiv) and (egyenes[egyenesszam].letezes) then
 begin
 egyenes_szamol(egyenesszam);

 x1:=egyenes[egyenesszam].x1;//hogy mirt rtam ki a vltozkat egy msikba:
 y1:=egyenes[egyenesszam].y1;//lsd a szakaszkirak-nl!
 x2:=egyenes[egyenesszam].x2;//ott is pontosan ugyanez van
 y2:=egyenes[egyenesszam].y2;
 szog:=egyenes[egyenesszam].szog+piper2;
 szinusz:=sin(szog);
 koszinusz:=cos(szog);

 piros:=arnyekR; //az szakaszarnyekkirak-nl mshogy van megoldva, hogy
 zold:=arnyekG;  //az rnyk szneit rajzolja ki, de mind a ketto
 kek:=arnyekB;   //ugyanazt "muveli"


 if egyenes[egyenesszam].meret=1
 then lineclipped(sprite01,x1+arnyektolX,y1+arnyektolY,x2+arnyektolX,
                  y2+arnyektolY,rgbtocol[piros,zold,kek])
 else lineclippedbold(sprite01,x1+arnyektolX,y1+arnyektolY,x2+arnyektolX,
                      y2+arnyektolY,egyenes[egyenesszam].meret,
                      piros,zold,kek);


 {lineclipped(sprite01,x1+arnyektolX,y1+arnyektolY,x2+arnyektolX,
             y2+arnyektolX,rgbtocol[piros,zold,kek]);

   if egyenes[egyenesszam].meret>1 then
   begin

   for k:=1 to egyenes[egyenesszam].meret-1 do
   if not paros(k) then
   lineclipped(sprite01,round(x1+((k div 2)+1)*koszinusz)+arnyektolX,
               round(y1+((k div 2)+1)*szinusz)+arnyektolY,
               round(x2+((k div 2)+1)*koszinusz)+arnyektolX,
               round(y2+((k div 2)+1)*szinusz)+arnyektolY,
               rgbtocol[piros,zold,kek])
                   else
   lineclipped(sprite01,round(x1-(k div 2)*koszinusz)+arnyektolX,
               round(y1-(k div 2)*szinusz)+arnyektolY,
               round(x2-(k div 2)*koszinusz)+arnyektolX,
               round(y2-(k div 2)*szinusz)+arnyektolY,
               rgbtocol[piros,zold,kek]);
   end;
  }
 end;

end;







// kirajzol a kpernyre egy krt
procedure korkirak(korszam:byte);
var
x,y,sugar:longint;
piros,zold,kek,k:byte;

begin

 if (kor[korszam].aktiv) and (kor[korszam].letezes) then
 begin
 kor_szamol(korszam);

 x:=kor[korszam].kx;
 y:=kor[korszam].ky;
 sugar:=kor[korszam].kr;

 piros:=kor[korszam].red;
 zold:=kor[korszam].green;
 kek:=kor[korszam].blue;

 circle(sprite01,x,y,sugar,piros,zold,kek);

   if kor[korszam].meret>1 then
   for k:=1 to kor[korszam].meret-1 do
   if not paros(k) then
   circle(sprite01,x,y,sugar+(k div 2)+1,piros,zold,kek)
                   else
   circle(sprite01,x,y,sugar-(k div 2),piros,zold,kek);

 end;

end;






// kirajzol a kpernyre egy krnek az rnykt
procedure korarnyekkirak(korszam:byte);
var
x,y,sugar:longint;
piros,zold,kek,k:byte;

begin

 if (kor[korszam].aktiv) and (kor[korszam].letezes) then
 begin
 kor_szamol(korszam);

 x:=kor[korszam].kx+arnyektolX;
 y:=kor[korszam].ky+arnyektolY;
 sugar:=kor[korszam].kr;

 piros:=arnyekR;
 zold:=arnyekG;
 kek:=arnyekB;

 circle(sprite01,x,y,sugar,piros,zold,kek);

   if kor[korszam].meret>1 then
   for k:=1 to kor[korszam].meret-1 do
   if not paros(k) then
   circle(sprite01,x,y,sugar+(k div 2)+1,piros,zold,kek)
                   else
   circle(sprite01,x,y,sugar-(k div 2),piros,zold,kek);

 end;

end;






// szgszmtsokhoz szksges fggvny
function szogmeres(x1,y1,x2,y2:real):real;
begin
{
    1         1               alfa          alfa
   /           \                2-------       2-------
  /             \               /               \
 /alfa           \alfa         /                 \
2---------       2--------    /                   \
                             1                     1
}

if not ((x1=x2) and (y1=y2)) then
   begin

   if (x1>x2) and (y1=y2) then szogmeres:=0;
   if (x1>x2) and (y1>y2) then szogmeres:=arctan( (y1-y2) / (x1-x2) );
   if (x1=x2) and (y1>y2) then szogmeres:=piper2;
   if (x1<x2) and (y1>y2) then szogmeres:=pi-arctan( (y1-y2) / (x2-x1) );
   if (x1<x2) and (y1=y2) then szogmeres:=pi;
   if (x1<x2) and (y1<y2) then szogmeres:=pi+arctan( (y2-y1) / (x2-x1) );
   if (x1=x2) and (y1<y2) then szogmeres:=pi+piper2;
   if (x1>x2) and (y1<y2) then szogmeres:=pi+piper2+arctan( (x1-x2) / (y2-y1) );

   end;

end;




// bemen adatknt meg kell adnod a koordintaskon kt pontot, s a
// fggvny visszatr a kt adott pontnak a tvolsgval
// (ehhez felhasznlom Pitagorasz ttelt)
function ketpont_tavolsaga(x1,y1,x2,y2:real):real;
begin
ketpont_tavolsaga:=sqrt( sqr(x1-x2) + sqr(y1-y2) );
end;





// ez az eljrs elforgatja (kpzeletben) az (x1;y1) pontot (ox;oy) orig
// krl SZOG szggel, s a keletkezett szg koordintit belerja az
// X2 s Y2-be
procedure forgat(szog,x1,y1,ox,oy:real;var x2,y2:real);
var
tav:real; //O es 1 pont tvolsga
alfa,gamma:real; //O es 1 kezdetleges szge

begin

tav:=ketpont_tavolsaga(x1,y1,ox,oy);
alfa:=szogmeres(x1,y1,ox,oy);
gamma:=alfa+szog;

x2:=ox+tav*cos(gamma);
y2:=oy+tav*sin(gamma);

end;






// kirajzol a kpernyre egy parabolt
procedure parabolakirak(pa:byte);
var
ii,paintval,pasu:longint; //F a fkuszpont
x2,y2,xf,yf,x1,y1,xc,yc:real; //C a tengelypont
eloszor:boolean;

px,py,kx,ky:longint; //ezeket kti ssze vonallal

begin
if (parabola[pa].aktiv) and (parabola[pa].letezes) then
 begin

 xc:=parabola[pa].x;
 yc:=parabola[pa].y-(parabola[pa].parameter/2);
 xf:=parabola[pa].x;
 yf:=parabola[pa].y;
 eloszor:=true;

 {if parabola[pa].parameter<50
 then paintval:=round(pa_intervallum*(parabola[pa].parameter/50))
 else paintval:=pa_intervallum;}
 paintval:=round(abs(parabola[pa].parameter))*6+50;
 pasu:= round(abs(parabola[pa].parameter)/20)+1;


   ii:=-paintval;
   repeat

   px:=kx;
   py:=ky;


   x1:=ii+xf;
   y1:=sqr(x1-xc)/(2*parabola[pa].parameter) + yc;

   forgat(parabola[pa].szog,x1,y1,xf,yf,x2,y2);

   kx:=round(x2);
   ky:=round(y2);

    if not eloszor then
     if parabola[pa].meret=1
     then lineclipped(sprite01,px,py,kx,ky,rgbtocol[ parabola[pa].red,
                      parabola[pa].green,parabola[pa].blue ])
     else lineclippedbold(sprite01,px,py,kx,ky,parabola[pa].meret,
                          parabola[pa].red,parabola[pa].green,
                          parabola[pa].blue);


   ii:=ii+pasu;
   eloszor:=false;
   until ii>paintval;

 end;

end;







// kirajzol a kpernyre egy parabolnak az rnykt
procedure parabolaarnyekkirak(pa:byte);
var
ii,paintval,pasu:longint; //F a fkuszpont
x2,y2,xf,yf,x1,y1,xc,yc:real; //C a tengelypont
eloszor:boolean;

px,py,kx,ky:longint; //ezeket kti ssze vonallal

begin
if (parabola[pa].aktiv) and (parabola[pa].letezes) then
 begin

 xc:=parabola[pa].x;
 yc:=parabola[pa].y-(parabola[pa].parameter/2);
 xf:=parabola[pa].x;
 yf:=parabola[pa].y;
 eloszor:=true;

 {if parabola[pa].parameter<50
 then paintval:=round(pa_intervallum*(parabola[pa].parameter/50))
 else paintval:=pa_intervallum;}
 paintval:=round(abs(parabola[pa].parameter))*6+50;
 pasu:= round(abs(parabola[pa].parameter)/20)+1;

   ii:=-paintval;
   repeat

   px:=kx;
   py:=ky;


   x1:=ii+xf;
   y1:=sqr(x1-xc)/(2*parabola[pa].parameter) + yc;

   forgat(parabola[pa].szog,x1,y1,xf,yf,x2,y2);

   kx:=round(x2);
   ky:=round(y2);

    if not eloszor then
     if parabola[pa].meret=1
     then lineclipped(sprite01,px+arnyektolX,py+arnyektolY,kx+arnyektolX,
                      ky+arnyektolY,rgbtocol[arnyekR,arnyekG,arnyekB])
     else lineclippedbold(sprite01,px+arnyektolX,py+arnyektolY,kx+arnyektolX,
                          ky+arnyektolY,parabola[pa].meret,
                          arnyekR,arnyekG,arnyekB);


   ii:=ii+pasu;
   eloszor:=false;
   until ii>paintval;

 end;

end;







//ha a pont rajta van az egyenesen akkor TRUE, klnben FALSE az rtke
//a fggvnynek (a parabola ltezsvizsglatnl van szksg erre)
function pontegyenesen(x,y,a,b,c,d:real;ab,cd:boolean):boolean;
begin

 if (ab) and (cd=false) and (y=b) then pontegyenesen:=true
                                  else pontegyenesen:=false;
 if (cd) and (ab=false) and (x=d) then pontegyenesen:=true
                                  else pontegyenesen:=false;
 if (ab) and (cd) and (y=a*x+b)   then pontegyenesen:=true
                                  else pontegyenesen:=false;

end;







function pontonvan(pontszam:byte):boolean;
var
eger_pont_tav:real;

begin
pont_szamol(pontszam);
eger_pont_tav:=ketpont_tavolsaga(pont[pontszam].kx,pont[pontszam].ky,m_x,m_y);
if round(eger_pont_tav)<=pont[pontszam].meret then pontonvan:=true
                                              else pontonvan:=false;
end;






//a bzispontokat megvilgostja, ha az egr ppen rajta van
//fontos, hogy a kzvetlen kirajzols elott legyen elhelyezve az eljrs
procedure pontvilagosit;
var
ii:longint;
r,g,b:byte;

begin
 for ii:=1 to 3 do
 begin
   if (pontonvan(ii)) or ((melyikmozgat=ii) and (mozgat)) then
   begin
   r:=pont[ii].red;
   g:=pont[ii].green;
   b:=pont[ii].blue;

   pont[ii].red:=round(r+ (31-r)*0.5);
   pont[ii].green:=round(g+ (63-g)*0.5);
   pont[ii].blue:=round(b+ (31-b)*0.5);
   end;

 end;

end;






procedure egerallapotok;
begin
m_ltomb[5]:=m_ltomb[4];
m_ltomb[4]:=m_ltomb[3];
m_ltomb[3]:=m_ltomb[2];
m_ltomb[2]:=m_ltomb[1];
m_ltomb[1]:=m_l;
end;






// ez az eljrs "mozgatja" a hromszg pontjait
procedure pontmozgat;
var
m:byte;

begin

if not mozgat then
  begin

  m:=0;
  mozgat:=false;

   repeat
   inc(m);

   if (pontonvan(m)) and (not m_ltomb[2]) and (m_l) and (pont[m].aktiv) and
      (pont[m].aktiv) then
   begin
   mozgat:=true;
   melyikmozgat:=m;
   end;

   until (m=3) or (mozgat);

  end

  else begin

    if m_l then
    begin

       if melyikmozgat=1 then
       begin

         if m_y+2<szerkeszty then
          begin
          pont[melyikmozgat].x:=m_x;
          pont[melyikmozgat].y:=m_y;
          end
         else
          begin
          pont[melyikmozgat].x:=m_x;
          pont[melyikmozgat].y:=szerkeszty-3;
          end;

       end;

       if melyikmozgat=2 then
       begin

         if m_y+2<szerkeszty then
          begin
          pont[melyikmozgat].x:=m_x+0.1;
          pont[melyikmozgat].y:=m_y+0.1;
          end
         else
          begin
          pont[melyikmozgat].x:=m_x+0.1;
          pont[melyikmozgat].y:=szerkeszty-3+0.1;
          end;

       end;

       if melyikmozgat=3 then
       begin

         if m_y+2<szerkeszty then
          begin
          pont[melyikmozgat].x:=m_x-0.1;
          pont[melyikmozgat].y:=m_y-0.1;
          end
         else
          begin
          pont[melyikmozgat].x:=m_x-0.1;
          pont[melyikmozgat].y:=szerkeszty-3-0.1;
          end;

       end;


     pont_szamol(melyikmozgat);

    end
    else begin
    mozgat:=false;
    end;

  end;

end;





//az ELEMEK eljrsai!!!!



procedure Qketpontra_szakasz(p1,p2:byte;sz:byte);
begin
if (pont[p1].letezes) and (pont[p2].letezes) then
   begin
   szakasz[sz].letezes:=true;
   szakasz[sz].x1:=pont[p1].x;
   szakasz[sz].y1:=pont[p1].y;
   szakasz[sz].x2:=pont[p2].x;
   szakasz[sz].y2:=pont[p2].y;
   end
   else szakasz[sz].letezes:=false;

end;







procedure Qketpontra_egyenes(p1,p2:byte;e:byte);
begin
if (pont[p1].letezes) and (pont[p2].letezes) then
   begin
   egyenes[e].letezes:=true;
   ketpont_egyenesenek_abcdszog(pont[p1].x,pont[p1].y,pont[p2].x,pont[p2].y,
                                egyenes[e].a,egyenes[e].b,egyenes[e].c,
                                egyenes[e].d,egyenes[e].szog,egyenes[e].ab,
                                egyenes[e].cd);
   end
   else egyenes[e].letezes:=false;

end;







procedure Qketpont_felezoje(p1,p2:byte;p3:byte);
begin
if (pont[p1].letezes) and (pont[p2].letezes) then
   begin
   pont[p3].letezes:=true;
   szakaszfelezo(pont[p1].x,pont[p1].y,pont[p2].x,pont[p2].y,
                 pont[p3].x,pont[p3].y);
   pont_szamol(p3);
   end
   else pont[p3].letezes:=false;

end;







procedure Qponton_atmeno_egyenesremeroleges(p,e1:byte;e2:byte);
begin
if (pont[p].letezes) and (egyenes[e1].letezes) then
    begin
    egyenes[e2].letezes:=true;
    pontonatmeno_egyenesre_meroleges(egyenes[e1].a,egyenes[e1].b,
                                    egyenes[e1].c,egyenes[e1].d,
                                    egyenes[e1].ab,egyenes[e1].cd,
                                    pont[p].x,pont[p].y,
                                    egyenes[e2].a,egyenes[e2].b,
                                    egyenes[e2].c,egyenes[e2].d,
                                    egyenes[e2].szog,egyenes[e2].ab,
                                    egyenes[e2].cd);
    end
    else egyenes[e2].letezes:=false;

end;







procedure Qpontnak_egyenesre_talppontja(p,e:byte;p2:byte);
begin
if (pont[p].letezes) and (egyenes[e].letezes) then
    begin
    pont[p2].letezes:=true;
    pontnak_egyenesre_talppontja(egyenes[e].a,egyenes[e].b,egyenes[e].c,
                                 egyenes[e].d,egyenes[e].ab,egyenes[e].cd,
                                 pont[p].x,pont[p].y,pont[p2].x,pont[p2].y);
    end
    else pont[p2].letezes:=false;

end;









procedure Qketegyenes_metszespontja(e1,e2:byte;p:byte);
begin
if (egyenes[e1].letezes) and (egyenes[e2].letezes) then
    begin
    pont[p].letezes:=true;
    ketegyenes_metszespontja(egyenes[e1].a,egyenes[e1].b,egyenes[e1].c,
                             egyenes[e1].d,egyenes[e2].a,egyenes[e2].b,
                             egyenes[e2].c,egyenes[e2].d,egyenes[e1].ab,
                             egyenes[e1].cd,egyenes[e2].ab,egyenes[e2].cd,
                             pont[p].x,pont[p].y,pont[p].letezes);
    end
    else pont[p].letezes:=false;

end;









procedure Qharompontra_szogfelezo(p1,p2,p3:byte;e:byte);
begin
if (pont[p1].letezes) and (pont[p2].letezes) and (pont[p3].letezes) then
   begin

   harompontra_szogfelezo(pont[p1].x,pont[p1].y,pont[p2].x,pont[p2].y,
                          pont[p3].x,pont[p3].y,egyenes[e].a,
                          egyenes[e].b,egyenes[e].c,egyenes[e].d,
                          egyenes[e].szog,egyenes[e].ab,egyenes[e].cd);

     if not ((egyenes[e].ab=false) and (egyenes[e].cd=false))
     then egyenes[e].letezes:=true
     else egyenes[e].letezes:=false;

   end
   else egyenes[e].letezes:=false;

end;












procedure Qketpont_tavolsaga(p1,p2:byte;tav:real;letezik:boolean);
begin
if (pont[p1].letezes) and (pont[p2].letezes) then
   begin
   tav:=ketpont_tavolsaga(pont[p1].x,pont[p1].y,pont[p2].x,pont[p2].y);
   letezik:=true;
   end
   else letezik:=false;

end;








procedure Qpontkerpont_kor(p,ker:byte;k:byte);
begin
if (pont[p].letezes) and (pont[ker].letezes) then
   begin
   kor[k].letezes:=true;
   kor[k].x:=pont[p].x;
   kor[k].y:=pont[p].y;
   kor[k].r:=ketpont_tavolsaga(pont[p].x,pont[p].y,pont[ker].x,pont[ker].y);

   end
   else kor[k].letezes:=false;

end;








procedure Qpontegyenesre_parabola(p,e:byte;pa:byte);
var
a,b,c,d,szog:real; //meroleges egyenes
ab,cd:boolean;

begin


if (pont[p].letezes) and (egyenes[e].letezes) and
   (pontegyenesen(pont[p].x,pont[p].y,egyenes[e].a,egyenes[e].b,
                  egyenes[e].c,egyenes[e].d,egyenes[e].ab,
                  egyenes[e].cd)=false) then
   begin
   parabola[pa].letezes:=true;

    parabola[pa].x:=pont[p].x;
    parabola[pa].y:=pont[p].y;

    parabola[pa].a:=egyenes[e].a;
    parabola[pa].b:=egyenes[e].b;
    parabola[pa].c:=egyenes[e].c;
    parabola[pa].d:=egyenes[e].d;
    parabola[pa].szog:=egyenes[e].szog;

    parabola[pa].ab:=egyenes[e].ab;
    parabola[pa].cd:=egyenes[e].cd;

   pontonatmeno_egyenesre_meroleges(egyenes[e].a,egyenes[e].b,egyenes[e].c,
                                    egyenes[e].d,egyenes[e].ab,egyenes[e].cd,
                                    pont[p].x,pont[p].y, a,b,c,d,szog, ab,cd);

    ketegyenes_metszespontja(egyenes[e].a,egyenes[e].b,egyenes[e].c,
                             egyenes[e].d,a,b,c,d,egyenes[e].ab,
                             egyenes[e].cd,ab,cd, parabola[pa].tx,
                             parabola[pa].ty,hulyesegboolean);

    parabola[pa].parameter:= ketpont_tavolsaga(parabola[pa].x,parabola[pa].y,
                                            parabola[pa].tx,parabola[pa].ty);
    if parabola[pa].ab then
     if parabola[pa].y<parabola[pa].ty then
      parabola[pa].parameter:=-parabola[pa].parameter;
    if (parabola[pa].ab=false) and (parabola[pa].cd=true) then
     if parabola[pa].x>parabola[pa].tx then
      parabola[pa].parameter:=-parabola[pa].parameter;



   end
   else parabola[pa].letezes:=false;

end;








// Erre az eljrsra nincs szksg a programban, de azrt rtam, mert valaha
// volt. Mgpedig a fejleszts alatt egyszer szksg volt arra, hogy egy
// MT_TYPE tpus vltoznak az adatait tmsolja egy msikba. Mghozz
// pontosabban az MFROM adatait az MTO-ba.
// Azrt nem szoktam kitrlni a "flsleges" eljrsokat, mert lehet,
// hogy egyszer mg szksg lesz r.
procedure move_mt(mfrom,mto:mt_type);
begin

{MT adatainak ttltse az MT2-be!}
for j:=2 to 10 do
  begin

   for i:=1 to pontok_szama do
   begin
   mto[j].pont[i].aktiv:=mfrom[j].pont[i].aktiv;
   mto[j].pont[i].meret:=mfrom[j].pont[i].meret;
   mto[j].pont[i].r:=mfrom[j].pont[i].r;
   mto[j].pont[i].g:=mfrom[j].pont[i].g;
   mto[j].pont[i].b:=mfrom[j].pont[i].b;
   end;

   for i:=1 to szakaszok_szama do
   begin
   mto[j].szakasz[i].aktiv:=mfrom[j].szakasz[i].aktiv;
   mto[j].szakasz[i].meret:=mfrom[j].szakasz[i].meret;
   mto[j].szakasz[i].r:=mfrom[j].szakasz[i].r;
   mto[j].szakasz[i].g:=mfrom[j].szakasz[i].g;
   mto[j].szakasz[i].b:=mfrom[j].szakasz[i].b;
   end;

   for i:=1 to egyenesek_szama do
   begin
   mto[j].egyenes[i].aktiv:=mfrom[j].egyenes[i].aktiv;
   mto[j].egyenes[i].meret:=mfrom[j].egyenes[i].meret;
   mto[j].egyenes[i].r:=mfrom[j].egyenes[i].r;
   mto[j].egyenes[i].g:=mfrom[j].egyenes[i].g;
   mto[j].egyenes[i].b:=mfrom[j].egyenes[i].b;
   end;

   for i:=1 to korok_szama do
   begin
   mto[j].kor[i].aktiv:=mfrom[j].kor[i].aktiv;
   mto[j].kor[i].meret:=mfrom[j].kor[i].meret;
   mto[j].kor[i].r:=mfrom[j].kor[i].r;
   mto[j].kor[i].g:=mfrom[j].kor[i].g;
   mto[j].kor[i].b:=mfrom[j].kor[i].b;
   end;


  end;

end;







procedure fill_mt;
begin

{a kezdetleges llapot (valsznu erre ksobb mr nem lesz szksg)}
for i:=1 to 3 do begin pont[i].aktiv:=true;  //bzispontok
                       pont[i].letezes:=true;
                       pont[i].meret:=5;
                       pont[i].red:=5;
                       pont[i].green:=10;
                       pont[i].blue:=5;

                       szakasz[i].aktiv:=true; //a 3szg oldalai
                       szakasz[i].meret:=3;
                       szakasz[i].red:=5;
                       szakasz[i].green:=10;
                       szakasz[i].blue:=5;

                       egyenes[i].aktiv:=true; //a 3szg oldalegyenesei
                       egyenes[i].meret:=1;
                       egyenes[i].red:=16;
                       egyenes[i].green:=32;
                       egyenes[i].blue:=16;
                 end;

for i:=4 to 6 do begin pont[i].meret:=3; //oldalfelezopontok
                       pont[i].red:=31;
                       pont[i].green:=0;
                       pont[i].blue:=31;

                       szakasz[i].meret:=2; //slyvonalak(szakaszok)
                       szakasz[i].red:=20;
                       szakasz[i].green:=0;
                       szakasz[i].blue:=20;
                 end;


for i:=7 to 9 do begin pont[i].meret:=3; //3szg egyik pontjnak talppontja
                       pont[i].red:=0;   //a szemkzti oldalegyenesre
                       pont[i].green:=50;
                       pont[i].blue:=0;

                       szakasz[i].meret:=2; // magassgszakaszok
                       szakasz[i].red:=16;
                       szakasz[i].green:=32;
                       szakasz[i].blue:=16;

                       egyenes[i].meret:=1; // magassgegyenes
                       egyenes[i].red:=16;
                       egyenes[i].green:=32;
                       egyenes[i].blue:=31;
                 end;

pont[13].meret:=3; //krrt kr kp.-ja
pont[13].red:=31;
pont[13].green:=6;
pont[13].blue:=3;

pont[14].meret:=2; //bert kr kp.-ja
pont[14].red:=3;
pont[14].green:=6;
pont[14].blue:=31;

pont[15].meret:=3; //magassgpont
pont[15].red:=0;
pont[15].green:=0;
pont[15].blue:=25;

pont[16].meret:=3; //slypont
pont[16].red:=31;
pont[16].green:=30;
pont[16].blue:=31;


for i:=10 to 12 do begin egyenes[i].meret:=1; // oldalfelezo merolegesek
                         egyenes[i].red:=31;
                         egyenes[i].green:=30;
                         egyenes[i].blue:=15;

                         pont[i].meret:=2; // hozzrt krk kp.-jai
                         pont[i].red:=31;
                         pont[i].green:=0;
                         pont[i].blue:=0;

                         szakasz[i].meret:=1; // belso szgfelezoszakaszok
                         szakasz[i].red:=22;
                         szakasz[i].green:=44;
                         szakasz[i].blue:=22;
                   end;

for i:=13 to 15 do begin egyenes[i].meret:=1; // belso szgfelezok
                         egyenes[i].red:=15;
                         egyenes[i].green:=30;
                         egyenes[i].blue:=31;

                         szakasz[i].meret:=2; // talpponti 3szg oldalai
                         szakasz[i].red:=0;
                         szakasz[i].green:=40;
                         szakasz[i].blue:=20;
                   end;

for i:=16 to 18 do begin egyenes[i].meret:=1; // kulso szgfelezok
                         egyenes[i].red:=15;
                         egyenes[i].green:=30;
                         egyenes[i].blue:=31;
                   end;

pont[17].letezes:=true; //simson pont
pont[17].meret:=3;
pont[17].red:=31;
pont[17].green:=0;
pont[17].blue:=0;

for i:=18 to 20 do begin pont[i].meret:=2; //simson talppontok
                         pont[i].red:=31;
                         pont[i].green:=26;
                         pont[i].blue:=13;
                   end;


kor[1].red:=25;kor[1].green:=50;kor[1].blue:=5; //krrt kr
kor[1].meret:=5;


kor[2].red:=5;kor[2].green:=63;kor[2].blue:=5; //bert kr
kor[2].meret:=4;

for i:=3 to 5 do begin kor[i].meret:=2; //hozzrt krk
                       kor[i].red:=5;
                       kor[i].green:=31;
                       kor[i].blue:=5;
                 end;

egyenes[19].meret:=2; // euler-egyenes
egyenes[19].red:=31;
egyenes[19].green:=6;
egyenes[19].blue:=3;

egyenes[20].meret:=2; // simson_egyenes
egyenes[20].red:=31;
egyenes[20].green:=6;
egyenes[20].blue:=3;


//az elemek megjelensi adatainak vge
{kezdetleges llapot vge}


//mt feltltse

//nullzs
for j:=2 to 10 do //mert a srgamen 2-10 kztt vehet fel rtket
 begin
                        //visszatr a ngy elemszm kzl a legnagyobbal
                 for i:=1 to max( max(pontok_szama,szakaszok_szama) ,
                                  max(egyenesek_szama,korok_szama) ) do
                 begin

                     if i<=pontok_szama then
                       begin
                       mt[j].pont[i].aktiv:=false;
                       mt[j].pont[i].meret:=1;
                       mt[j].pont[i].r:=0;
                       mt[j].pont[i].g:=0;
                       mt[j].pont[i].b:=0;
                       end;
                     if i<=szakaszok_szama then
                       begin
                       mt[j].szakasz[i].aktiv:=false;
                       mt[j].szakasz[i].meret:=1;
                       mt[j].szakasz[i].r:=0;
                       mt[j].szakasz[i].g:=0;
                       mt[j].szakasz[i].b:=0;
                       end;

                     if i<=egyenesek_szama then
                       begin
                       mt[j].egyenes[i].aktiv:=false;
                       mt[j].egyenes[i].meret:=1;
                       mt[j].egyenes[i].r:=0;
                       mt[j].egyenes[i].g:=0;
                       mt[j].egyenes[i].b:=0;
                       end;

                     if i<=korok_szama then
                       begin
                       mt[j].kor[i].aktiv:=false;
                       mt[j].kor[i].meret:=1;
                       mt[j].kor[i].r:=0;
                       mt[j].kor[i].g:=0;
                       mt[j].kor[i].b:=0;
                       end;

                     if i<=parabolak_szama then
                       begin
                       mt[j].parabola[i].aktiv:=false;
                       mt[j].parabola[i].meret:=1;
                       mt[j].parabola[i].r:=0;
                       mt[j].parabola[i].g:=0;
                       mt[j].parabola[i].b:=0;
                       end;

                  end;
 end;





{ 2. krrt kr }
    for i:=1 to 3 do
    begin
    mt[2].pont[i].aktiv:=true; //bzispontok
    mt[2].pont[i].meret:=5;
    mt[2].pont[i].r:=0;
    mt[2].pont[i].g:=1;
    mt[2].pont[i].b:=0;

    mt[2].szakasz[i].aktiv:=true; //3szg-oldalak
    mt[2].szakasz[i].meret:=2;
    mt[2].szakasz[i].r:=0;
    mt[2].szakasz[i].g:=1;
    mt[2].szakasz[i].b:=0;

    mt[2].egyenes[i].aktiv:=true; //oldalegyenesek
    mt[2].egyenes[i].meret:=1;
    mt[2].egyenes[i].r:=0;
    mt[2].egyenes[i].g:=1;
    mt[2].egyenes[i].b:=0;
    end;

    for i:=4 to 6 do
    begin
    mt[2].pont[i].aktiv:=true; //oldalfelezo pontok
    mt[2].pont[i].meret:=2;
    mt[2].pont[i].r:=31;
    mt[2].pont[i].g:=16;
    mt[2].pont[i].b:=8;
    end;

    {7,8,9-bol nem kell}

    for i:=10 to 12 do
    begin
    mt[2].egyenes[i].aktiv:=true; //oldalfelezo merolegesek
    mt[2].egyenes[i].meret:=1;
    mt[2].egyenes[i].r:=31;
    mt[2].egyenes[i].g:=20;
    mt[2].egyenes[i].b:=10;
    end;

    mt[2].pont[13].aktiv:=true; //krrt kr kp.-ja
    mt[2].pont[13].meret:=2;
    mt[2].pont[13].r:=18;
    mt[2].pont[13].g:=0;
    mt[2].pont[13].b:=0;

    mt[2].kor[1].aktiv:=true; //krrt kr
    mt[2].kor[1].meret:=3;
    mt[2].kor[1].r:=20;
    mt[2].kor[1].g:=0;
    mt[2].kor[1].b:=0;


{ 3. bert kr }
    for i:=1 to 3 do
    begin
    mt[3].pont[i].aktiv:=true; //bzispontok
    mt[3].pont[i].meret:=5;
    mt[3].pont[i].r:=0;
    mt[3].pont[i].g:=1;
    mt[3].pont[i].b:=0;

    mt[3].szakasz[i].aktiv:=true; //oldalak
    mt[3].szakasz[i].meret:=2;
    mt[3].szakasz[i].r:=0;
    mt[3].szakasz[i].g:=1;
    mt[3].szakasz[i].b:=0;;
    end;

    {4,5,6-bl nem kell}
    {7,8,9-bol nem kell}

    for i:=10 to 12 do begin
    mt[3].szakasz[i].aktiv:=true;  //belso szgfelezo szakaszok
    mt[3].szakasz[i].meret:=1;
    mt[3].szakasz[i].r:=10;
    mt[3].szakasz[i].g:=63;
    mt[3].szakasz[i].b:=10;
    end;

    mt[3].pont[14].aktiv:=true; //bert kr kp.-ja
    mt[3].pont[14].meret:=2;
    mt[3].pont[14].r:=5;
    mt[3].pont[14].g:=40;
    mt[3].pont[14].b:=5;

    mt[3].kor[2].aktiv:=true; //bert kr
    mt[3].kor[2].meret:=3;
    mt[3].kor[2].r:=0;
    mt[3].kor[2].g:=40;
    mt[3].kor[2].b:=0;


{ 4. magassg}
    for i:=1 to 3 do
    begin
    mt[4].pont[i].aktiv:=true; //bzispontok
    mt[4].pont[i].meret:=5;
    mt[4].pont[i].r:=0;
    mt[4].pont[i].g:=1;
    mt[4].pont[i].b:=0;

    mt[4].szakasz[i].aktiv:=true; //oldalak
    mt[4].szakasz[i].meret:=2;
    mt[4].szakasz[i].r:=0;
    mt[4].szakasz[i].g:=1;
    mt[4].szakasz[i].b:=0;;
    end;

    {4,5,6-bl nem kell}

    for i:=7 to 9 do
    begin
    mt[4].pont[i].aktiv:=true; //talppontok
    mt[4].pont[i].meret:=3;
    mt[4].pont[i].r:=13;
    mt[4].pont[i].g:=42;
    mt[4].pont[i].b:=31;

    mt[4].egyenes[i].aktiv:=true; //magassgegyenesek
    mt[4].egyenes[i].meret:=1;
    mt[4].egyenes[i].r:=0;
    mt[4].egyenes[i].g:=0;
    mt[4].egyenes[i].b:=20;
    end;

    {10,11,12-bol nem kell}

    mt[4].pont[15].aktiv:=true; //magassgpont
    mt[4].pont[15].meret:=4;
    mt[4].pont[15].r:=16;
    mt[4].pont[15].g:=32;
    mt[4].pont[15].b:=31;


{ 5. slypont}
    for i:=1 to 3 do
    begin
    mt[5].pont[i].aktiv:=true; //bzispontok
    mt[5].pont[i].meret:=5;
    mt[5].pont[i].r:=0;
    mt[5].pont[i].g:=1;
    mt[5].pont[i].b:=0;

    mt[5].szakasz[i].aktiv:=true; //oldalak
    mt[5].szakasz[i].meret:=2;
    mt[5].szakasz[i].r:=0;
    mt[5].szakasz[i].g:=1;
    mt[5].szakasz[i].b:=0;;
    end;

    for i:=4 to 6 do
    begin
    mt[5].pont[i].aktiv:=true; //oldalfelezo pontok
    mt[5].pont[i].meret:=3;
    mt[5].pont[i].r:=31;
    mt[5].pont[i].g:=30;
    mt[5].pont[i].b:=15;

    mt[5].szakasz[i].aktiv:=true; //slyvonal szakaszok
    mt[5].szakasz[i].meret:=1;
    mt[5].szakasz[i].r:=31;
    mt[5].szakasz[i].g:=14;
    mt[5].szakasz[i].b:=7;
    end;

    mt[5].pont[16].aktiv:=true; //slypont
    mt[5].pont[16].meret:=4;
    mt[5].pont[16].r:=20;
    mt[5].pont[16].g:=0;
    mt[5].pont[16].b:=0;


{ 6. hozzrt krk}
    for i:=1 to 3 do
    begin
    mt[6].pont[i].aktiv:=true; //bzispontok
    mt[6].pont[i].meret:=5;
    mt[6].pont[i].r:=0;
    mt[6].pont[i].g:=1;
    mt[6].pont[i].b:=0;

    mt[6].szakasz[i].aktiv:=true; //3szg-oldalak
    mt[6].szakasz[i].meret:=2;
    mt[6].szakasz[i].r:=0;
    mt[6].szakasz[i].g:=1;
    mt[6].szakasz[i].b:=0;

    mt[6].egyenes[i].aktiv:=true; //oldalegyenesek
    mt[6].egyenes[i].meret:=1;
    mt[6].egyenes[i].r:=0;
    mt[6].egyenes[i].g:=1;
    mt[6].egyenes[i].b:=0;
    end;

    {4,5,6-bl nem kell}
    {7,8,9-bol nem kell}

    for i:=10 to 12 do
    begin
    mt[6].pont[i].aktiv:=true; //hozzrt krk kp.-jai
    mt[6].pont[i].meret:=3;
    mt[6].pont[i].r:=5;
    mt[6].pont[i].g:=40;
    mt[6].pont[i].b:=5;
    end;

    for i:=16 to 18 do
    begin
    mt[6].egyenes[i].aktiv:=true; //klso szgfelezo egyenesek
    mt[6].egyenes[i].meret:=1;
    mt[6].egyenes[i].r:=10;
    mt[6].egyenes[i].g:=53;
    mt[6].egyenes[i].b:=10;
    end;

    for i:=3 to 5 do
    begin
    mt[6].kor[i].aktiv:=true; //hozzrt krk
    mt[6].kor[i].meret:=2;
    mt[6].kor[i].r:=5;
    mt[6].kor[i].g:=40;
    mt[6].kor[i].b:=5;
    end;


{ 7. euler-egyenes}
    for i:=1 to 3 do
    begin
    mt[7].pont[i].aktiv:=true; //bzispontok
    mt[7].pont[i].meret:=5;
    mt[7].pont[i].r:=0;
    mt[7].pont[i].g:=1;
    mt[7].pont[i].b:=0;

    mt[7].szakasz[i].aktiv:=true; //oldalak
    mt[7].szakasz[i].meret:=2;
    mt[7].szakasz[i].r:=0;
    mt[7].szakasz[i].g:=1;
    mt[7].szakasz[i].b:=0;;
    end;

    {4,5,6-bl nem kell}
    {7,8,9-bol nem kell}
    {10,11,12-bol nem kell}

    mt[7].pont[13].aktiv:=true; //kr rt kr kp.-ja
    mt[7].pont[13].meret:=4;
    mt[7].pont[13].r:=31;
    mt[7].pont[13].g:=0;
    mt[7].pont[13].b:=0;

    mt[7].pont[16].aktiv:=true; //slypont
    mt[7].pont[16].meret:=4;
    mt[7].pont[16].r:=0;
    mt[7].pont[16].g:=63;
    mt[7].pont[16].b:=0;

    mt[7].pont[15].aktiv:=true; //magasgpont
    mt[7].pont[15].meret:=4;
    mt[7].pont[15].r:=0;
    mt[7].pont[15].g:=0;
    mt[7].pont[15].b:=31;

    mt[7].egyenes[19].aktiv:=true; //euler-egyenes
    mt[7].egyenes[19].meret:=2;
    mt[7].egyenes[19].r:=18;
    mt[7].egyenes[19].g:=36;
    mt[7].egyenes[19].b:=31;


{ 8. talpponti hromszg}
    for i:=1 to 3 do
    begin
    mt[8].pont[i].aktiv:=true; //bzispontok
    mt[8].pont[i].meret:=5;
    mt[8].pont[i].r:=0;
    mt[8].pont[i].g:=1;
    mt[8].pont[i].b:=0;

    mt[8].szakasz[i].aktiv:=true; //3szg-oldalak
    mt[8].szakasz[i].meret:=2;
    mt[8].szakasz[i].r:=0;
    mt[8].szakasz[i].g:=1;
    mt[8].szakasz[i].b:=0;

    mt[8].egyenes[i].aktiv:=true; //oldalegyenesek
    mt[8].egyenes[i].meret:=1;
    mt[8].egyenes[i].r:=0;
    mt[8].egyenes[i].g:=1;
    mt[8].egyenes[i].b:=0;
    end;

    {4,5,6-bl nem kell}

    for i:=7 to 9 do
    begin
    mt[8].pont[i].aktiv:=true; //talppontok
    mt[8].pont[i].meret:=3;
    mt[8].pont[i].r:=10;
    mt[8].pont[i].g:=63;
    mt[8].pont[i].b:=10;
    end;

    {10,11,12-bol nem kell}

    for i:=13 to 15 do
    begin
    mt[8].szakasz[i].aktiv:=true; //talpponti hromszg oldalai
    mt[8].szakasz[i].meret:=2;
    mt[8].szakasz[i].r:=0;
    mt[8].szakasz[i].g:=45;
    mt[8].szakasz[i].b:=0;
    end;


{ 9. simson-egyenes}
    for i:=1 to 3 do
    begin
    mt[9].pont[i].aktiv:=true; //bzispontok
    mt[9].pont[i].meret:=5;
    mt[9].pont[i].r:=0;
    mt[9].pont[i].g:=1;
    mt[9].pont[i].b:=0;

    mt[9].szakasz[i].aktiv:=true; //3szg-oldalak
    mt[9].szakasz[i].meret:=2;
    mt[9].szakasz[i].r:=0;
    mt[9].szakasz[i].g:=1;
    mt[9].szakasz[i].b:=0;

    mt[9].egyenes[i].aktiv:=true; //oldalegyenesek
    mt[9].egyenes[i].meret:=1;
    mt[9].egyenes[i].r:=0;
    mt[9].egyenes[i].g:=1;
    mt[9].egyenes[i].b:=0;
    end;

    {4,5,6-bl nem kell}
    {7,8,9-bol nem kell}
    {10,11,12-bol nem kell}

    mt[9].pont[13].aktiv:=true; //krrt kr kp.-ja
    mt[9].pont[13].meret:=2;
    mt[9].pont[13].r:=31;
    mt[9].pont[13].g:=40;
    mt[9].pont[13].b:=20;

    mt[9].pont[17].aktiv:=true; //simson pont
    mt[9].pont[17].meret:=5;
    mt[9].pont[17].r:=31;
    mt[9].pont[17].g:=30;
    mt[9].pont[17].b:=15;

    for i:=18 to 20 do
    begin
    mt[9].pont[i].aktiv:=true; //simson talppontok
    mt[9].pont[i].meret:=3;
    mt[9].pont[i].r:=31;
    mt[9].pont[i].g:=50;
    mt[9].pont[i].b:=13;
    end;

    mt[9].egyenes[20].aktiv:=true; //simson-egyenes
    mt[9].egyenes[20].meret:=2;
    mt[9].egyenes[20].r:=31;
    mt[9].egyenes[20].g:=20;
    mt[9].egyenes[20].b:=10;

    mt[9].kor[1].aktiv:=true; //krrt kr
    mt[9].kor[1].meret:=3;
    mt[9].kor[1].r:=16;
    mt[9].kor[1].g:=0;
    mt[9].kor[1].b:=0;


{ 10. parabolk}
     for i:=1 to 3 do
     begin
     mt[10].pont[i].aktiv:=true; //bzispontok
     mt[10].pont[i].meret:=5;
     mt[10].pont[i].r:=0;
     mt[10].pont[i].g:=1;
     mt[10].pont[i].b:=0;

     mt[10].szakasz[i].aktiv:=true; //3szg-oldalak
     mt[10].szakasz[i].meret:=2;
     mt[10].szakasz[i].r:=0;
     mt[10].szakasz[i].g:=1;
     mt[10].szakasz[i].b:=0;

     mt[10].egyenes[i].aktiv:=true; //oldalegyenesek
     mt[10].egyenes[i].meret:=1;
     mt[10].egyenes[i].r:=20;
     mt[10].egyenes[i].g:=40;
     mt[10].egyenes[i].b:=20;

     mt[10].parabola[i].aktiv:=true; //parabolk
     mt[10].parabola[i].meret:=2;
     mt[10].parabola[i].r:=0;
     mt[10].parabola[i].g:=0;
     mt[10].parabola[i].b:=25;
     end;

     for i:=13 to 15 do
     begin
     mt[10].egyenes[i].aktiv:=true; //belso szgfelezo egyenesek
     mt[10].egyenes[i].meret:=2;
     mt[10].egyenes[i].r:=0;
     mt[10].egyenes[i].g:=50;
     mt[10].egyenes[i].b:=0;
     end;




//move_mt(mt,mt2);
{move_mt(mt2,mt3);
move_mt(mt3,mt4);
move_mt(mt4,mt5);
move_mt(mt5,mt6);}


for i:=1 to 3 do pont[i].letezes:=true;  //enlkl nem lteznek a pontok!!!
{fill_mt eljrs vge}
end;









//a gp gyorsasgt jellemzo szam az mp
procedure mp_kiszamitas;
var
elotte,utana:longint;
begin
//megnzi, hogy a gp 3 msodperc alatt meddig tud elszmolni, s ezltal
//mri fel az adott gp gyorsasgt

elotte:=gettickcount;
mp:=0;

  repeat
  inc(mp);
  until gettickcount-elotte>=3000;

utana:=gettickcount;

gyorsitas:= (200*1000000) / mp ;
kiegyenlito:= Snevezoallando/mp;

end;








// a Simson-egyenes fontos dolgait szmolja ki (pl. mozgatja a krn lv
// pontot, stb.)
procedure simson_szamitasok;
var
tav:real;
ox,oy:longint;
begin

pont_szamol(13);
ox:=pont[13].kx; //krrt kr kp.-ja
oy:=pont[13].ky;


if (gombkattint(14)) and (gomb[14].szurke=false) then animacio:=true;
if (gombkattint(15)) and (gomb[15].szurke=false) then animacio:=false;

if (gombkattint(12)) and (gomb[12].szurke=false) then play:=false;
if (gombkattint(13)) and (gomb[13].szurke=false) then play:=true;

// tlls msik llapotra
if (gombkattint(13)) and (gomb[13].szurke=false) and (animacio=false) then begin
                                                                           animacio:=true;
                                                                           play:=true;
                                                                           pilseb:=0;
                                                                           end;


 // I. kzi vezrls
  if not animacio then
  begin

     //ha az egr nincs a krrt kr kp.-jban
    if (m_x<>ox) and (m_y<>oy) then
    begin

    tav:=sqrt( sqr(m_x-ox) + sqr(m_y-oy)  );

      if m_x<>ox then
                 if m_x>ox then simson_szog:=arctan(  (m_y-oy)/(m_x-ox))
                           else simson_szog:=arctan(  (m_y-oy)/(m_x-ox))+pi
                 else
                 if m_y>oy then simson_szog:=piper2
                           else simson_szog:=pi+piper2;



    end
    else pont[17].letezes:=false;

  end

   // II. animcis vezrls   (ha animacio=TRUE)
  else begin

   //lassts, play=FALSE
   if (play=false) and (pilseb>0) then pilseb:=pilseb-gyorsitas;
   if pilseb<=0 then pilseb:=0;
   //gyorsts, play=TRUE
   if (play) and (sebesseg>pilseb) then pilseb:=pilseb+gyorsitas;
   if (play) and (sebesseg<pilseb) then pilseb:=pilseb-gyorsitas;


   simson_szog:= simson_szog + degtorad( pilseb * kiegyenlito    )/220 ;

   if simson_szog>ketpi then simson_szog:=simson_szog-ketpi;


  end;




end;








// szzadmsodpercekben megadott ksleltets
// az eljrs akkor tr vissza, ha MP ezredmsodperc letelt
procedure kesleltet(mp:word);
var
eloszor:longint;

begin
eloszor:=gettickcount;

 repeat
 until gettickcount-eloszor>=mp;

end;







// Ez az eljrs kiszmolja a hromszg sszes nevezetes dolgait (amelyek
// majd kirajzolsra kerlhetnek).
// Mghozz pontosabban ez gy mkdik, hogy a program mindig kiszmolja
// az sszes krnek s egyensnek a pozcijt, mg akkor is ha az nem
// ltszik. Majd a vgn csak azokat rajzolja ki, amelyeket kell.
procedure szamolasi_Qeljarasok;
begin

//animci sebessg-belltsa
if (gombkattint(16)) and (sargamenu=9) then sebesseg:=gomb[16].y2-m_y;

Flip_VW(BackGround.VWOffset,Result.VWOffset);
scalesprite(ures,sprite01);



{ Qeljrsok }

Qketpont_felezoje(1,2,4); // a 3szg oldalainak felezopontja
Qketpont_felezoje(2,3,5);
Qketpont_felezoje(3,1,6);

Qketpontra_szakasz(1,2,1); // a 3szg oldalai
Qketpontra_szakasz(2,3,2);
Qketpontra_szakasz(3,1,3);

Qketpontra_egyenes(1,2,1); // a 3szg oldalegyenesei
Qketpontra_egyenes(2,3,2);
Qketpontra_egyenes(3,1,3);


Qpontnak_egyenesre_talppontja(3,1,7); // a 3szg talpontjai a szemkzti
Qpontnak_egyenesre_talppontja(1,2,8); // oldalegyenesre
Qpontnak_egyenesre_talppontja(2,3,9);

Qketpontra_szakasz(3,4,4); // a 3szg slyvonalai
Qketpontra_szakasz(1,5,5);
Qketpontra_szakasz(2,6,6);

Qketpontra_egyenes(3,4,4); // a 3szg slyvonalegyenesei
Qketpontra_egyenes(1,5,5);
Qketpontra_egyenes(2,6,6);

Qponton_atmeno_egyenesremeroleges(3,1,7); //magassgegyenesek
Qponton_atmeno_egyenesremeroleges(1,2,8);
Qponton_atmeno_egyenesremeroleges(2,3,9);

Qponton_atmeno_egyenesremeroleges(4,1,10); //oldalfelezo merolegesek
Qponton_atmeno_egyenesremeroleges(5,2,11);
Qponton_atmeno_egyenesremeroleges(6,3,12);


Qketegyenes_metszespontja(4,5,16); // slypont
Qketegyenes_metszespontja(7,8,15); // magassgpont
Qketegyenes_metszespontja(10,11,13); //krrt kr kp.-ja


Qpontkerpont_kor(13,1,1); // krrt kr


Qharompontra_szogfelezo(1,3,2,13); // belso szgfelezok
Qharompontra_szogfelezo(3,1,2,14);
Qharompontra_szogfelezo(1,2,3,15);

Qponton_atmeno_egyenesremeroleges(3,13,16); // klso szogfelezok CAB
Qponton_atmeno_egyenesremeroleges(1,14,17);
Qponton_atmeno_egyenesremeroleges(2,15,18);

Qketegyenes_metszespontja(13,14,14); // bert kr kp.-ja

Qketegyenes_metszespontja(16,18,10); // hozzrt krk kp.-jai   ABC
Qketegyenes_metszespontja(16,17,11);
Qketegyenes_metszespontja(17,18,12);

Qpontnak_egyenesre_talppontja(14,1,21); // bert kr kp.-ja az AB-re
                                        // vettett talppontja

Qpontnak_egyenesre_talppontja(10,1,22); // A-hoz tartoz hozzrt kr kp.-ja
Qpontnak_egyenesre_talppontja(11,1,23); // az AB-re talppontja
Qpontnak_egyenesre_talppontja(12,1,24);


Qpontkerpont_kor(14,21,2); // bert kr
Qpontkerpont_kor(10,22,3); // A-hoz tartoz hozzrt kr
Qpontkerpont_kor(11,23,4);
Qpontkerpont_kor(12,24,5);


Qketpontra_szakasz(3,7,7); // magassgszakaszok
Qketpontra_szakasz(1,8,8);
Qketpontra_szakasz(2,9,9);


Qketegyenes_metszespontja(13,1,25); // a belso szogfelezok es a szemkozti
Qketegyenes_metszespontja(14,2,26); // oldal metszese (a szgfelezoszakaszhoz
Qketegyenes_metszespontja(15,3,27); // van ra szksg)

Qketpontra_szakasz(3,25,10); // belso szgfelezoszakaszok
Qketpontra_szakasz(1,26,11);
Qketpontra_szakasz(2,27,12);


(*gyorsts*)
if sargamenu=7 then Qketpontra_egyenes(13,15,19); // euler-egyenes


Qketpontra_szakasz(7,8,13); // talpponti 3szg oldalai
Qketpontra_szakasz(8,9,14);
Qketpontra_szakasz(9,7,15);


if kor[1].letezes then pont[17].letezes:=true
                  else pont[17].letezes:=false;


(*gyorsts*)
if sargamenu=9 then begin

                     // simson pont helynek kiszmtsa
                     if pont[17].letezes then begin
                     pont[17].x:=kor[1].x+ kor[1].r*cos(simson_szog);
                     pont[17].y:=kor[1].y+ kor[1].r*sin(simson_szog);
                     pont_szamol(17);
                     end;

                     Qpontnak_egyenesre_talppontja(17,1,18); // a simson-pont talppontjai
                     Qpontnak_egyenesre_talppontja(17,2,19); // az oldalegyenesekre
                     Qpontnak_egyenesre_talppontja(17,3,20);


                     Qketpontra_egyenes(18,19,20); // simson-egyenes

                    end;

(*gyorsts*)
if sargamenu=10 then begin
                     Qpontegyenesre_parabola(3,1,1); //parabolk
                     Qpontegyenesre_parabola(1,2,2);
                     Qpontegyenesre_parabola(2,3,3);
                     end;

{ a Qeljrsok vge}



(*gyorsts*)
if sargamenu=9 then simson_szamitasok;



// az elemek belltsa, hogy melyik legyen lthat (MT ltal)
for i:=1 to pontok_szama do
 begin
 pont[i].aktiv:=mt[sargamenu].pont[i].aktiv;
 pont[i].meret:=mt[sargamenu].pont[i].meret;
 pont[i].red:=mt[sargamenu].pont[i].r;
 pont[i].green:=mt[sargamenu].pont[i].g;
 pont[i].blue:=mt[sargamenu].pont[i].b;
 end;

for i:=1 to szakaszok_szama do
 begin
 szakasz[i].aktiv:=mt[sargamenu].szakasz[i].aktiv;
 szakasz[i].meret:=mt[sargamenu].szakasz[i].meret;
 szakasz[i].red:=mt[sargamenu].szakasz[i].r;
 szakasz[i].green:=mt[sargamenu].szakasz[i].g;
 szakasz[i].blue:=mt[sargamenu].szakasz[i].b;
 end;

for i:=1 to egyenesek_szama do
 begin
 egyenes[i].aktiv:=mt[sargamenu].egyenes[i].aktiv;
 egyenes[i].meret:=mt[sargamenu].egyenes[i].meret;
 egyenes[i].red:=mt[sargamenu].egyenes[i].r;
 egyenes[i].green:=mt[sargamenu].egyenes[i].g;
 egyenes[i].blue:=mt[sargamenu].egyenes[i].b;
 end;

for i:=1 to korok_szama do
 begin
 kor[i].aktiv:=mt[sargamenu].kor[i].aktiv;
 kor[i].meret:=mt[sargamenu].kor[i].meret;
 kor[i].red:=mt[sargamenu].kor[i].r;
 kor[i].green:=mt[sargamenu].kor[i].g;
 kor[i].blue:=mt[sargamenu].kor[i].b;
 end;

for i:=1 to parabolak_szama do
 begin
 parabola[i].aktiv:=mt[sargamenu].parabola[i].aktiv;
 parabola[i].meret:=mt[sargamenu].parabola[i].meret;
 parabola[i].red:=mt[sargamenu].parabola[i].r;
 parabola[i].green:=mt[sargamenu].parabola[i].g;
 parabola[i].blue:=mt[sargamenu].parabola[i].b;
 end;


//if m_r then mp_kiszamitas;

end;







// Erre az eljrsra csak a program fejlesztse sorn volt szksg.
// Ez nem csinl mst, minthogy kir a kpernyre rengeteg informcit
// a geometriai elemekrl, stb...
procedure probaszoveg_kirakas;
begin

outtextxy(sprite01,10,10,31,0,0,  'srgamen='+longintstr(sargamenu));
outtextxy(sprite01,10,30,31,0,0,  'MT pont1:  mret'+longintstr(mt[sargamenu].pont[1].meret)+'   r'+longintstr(mt[sargamenu].pont[1].r) +'   g'+longintstr(mt[sargamenu].pont[1].g) +'   b'+longintstr(mt[sargamenu].pont[1].b)+
          +'   aktiv'+booleankepzo(mt[sargamenu].pont[1].aktiv) + '       PONT pont1: mret'+ longintstr(pont[1].meret)+ '   r'+longintstr(pont[1].red)+ '    g'+longintstr(pont[1].green)+'    b'+longintstr(pont[1].blue)+
          +'    aktiv'+booleankepzo(pont[1].aktiv)+booleankepzo(pont[1].letezes)     );
outtextxy(sprite01,10,40,31,0,0,  'MT pont2:  mret'+longintstr(mt[sargamenu].pont[2].meret)+'   r'+longintstr(mt[sargamenu].pont[2].r) +'   g'+longintstr(mt[sargamenu].pont[2].g) +'   b'+longintstr(mt[sargamenu].pont[2].b)+
          +'   aktiv'+booleankepzo(mt[sargamenu].pont[2].aktiv) + '       PONT pont2: mret'+ longintstr(pont[2].meret)+ '   r'+longintstr(pont[2].red)+ '    g'+longintstr(pont[2].green)+'    b'+longintstr(pont[2].blue)+
          +'    aktiv'+booleankepzo(pont[2].aktiv)+booleankepzo(pont[2].letezes)     );
outtextxy(sprite01,10,50,31,0,0,  'MT pont3:  mret'+longintstr(mt[sargamenu].pont[3].meret)+'   r'+longintstr(mt[sargamenu].pont[3].r) +'   g'+longintstr(mt[sargamenu].pont[3].g) +'   b'+longintstr(mt[sargamenu].pont[3].b)+
          +'   aktiv'+booleankepzo(mt[sargamenu].pont[3].aktiv) + '       PONT pont3: mret'+ longintstr(pont[3].meret)+ '   r'+longintstr(pont[3].red)+ '    g'+longintstr(pont[3].green)+'    b'+longintstr(pont[3].blue)+
          +'    aktiv'+booleankepzo(pont[3].aktiv)+booleankepzo(pont[3].letezes)     );

outtextxy(sprite01,10,60,0,63,0,'animacio'+booleankepzo(animacio)+'     Simson_szog='+longintstr(round(radtodeg(simson_szog)))+' fok');
outtextxy(sprite01,10,70,0,63,0,'sebessg'+longintstr(sebesseg)+'    pilseb'+longintstr(round(pilseb))   );
outtextxy(sprite01,10,80,0,0,31,'MP='+longintstr(mp));

outtextxy(sprite01,10,90,20,40,0,'parabolk surusge'  );

end;






// Ez az eljrs gondoskodik arrl, hogy kirajzoldjanak az objektumok
// (azaz geometriai elemek)
procedure elemek_kirajzolasa;
begin

pontvilagosit;

for i:=1 to parabolak_szama do parabolaarnyekkirak(i);
for i:=1 to korok_szama do korarnyekkirak(i);         // elemek rnyknak
for i:=1 to egyenesek_szama do egyenesarnyekkirak(i); // kirajzolsa a
for i:=1 to szakaszok_szama do szakaszarnyekkirak(i); // Sprite01 ablakra
for i:=pontok_szama downto 1 do pontarnyekkirak(i);

for i:=1 to parabolak_szama do parabolakirak(i);
for i:=1 to korok_szama do korkirak(i);         // elemek kirajzolsa
for i:=1 to egyenesek_szama do egyeneskirak(i); // a Sprite01 ablakra
for i:=1 to szakaszok_szama do szakaszkirak(i);
for i:=pontok_szama downto 1 do pontkirak(i);


pontmozgat;


PutHcSprite(result,sprite01,0,0,0);
for i:=1 to 16 do gombkirak(i);

if gombkattint(11) then sugob:=true; //sg meghvsa


end;






// Inicializlja a SIMSON PROGRAM fontos dolgait. Pldul belltja a
// 800x600 grafikt 16 bit sznnel, betlt nhny kpet......
procedure init_simson;
begin

 {

 gomb:  1:kilps
        2:krrt kr
        3:bert kr
        4:magassg                <- melyik szm melyik gombot jelli
        5:slypont
        6:hozzrt krk
        7:euler-egyenes
        8:talpponti 3szg
        9:simson-egyenes
       10:parabolk
       11:sg
       12:stop
       13:play
       14:krbenyl
       15:kz
       16:sebessg

 [-----------]
 [1          ]
 [          2]
 [-----------]


       }

mp_kiszamitas;

fill_rgbtocolor;

simson_szog:=0;
animacio:=true;
play:=false;
sugob:=false;
sfirst:=true;
fenyforras:=0;

       //       a gombok helyeit adja meg
{1}  gomb[1].x1:=14;gomb[1].y1:=499;gomb[1].x2:=80;gomb[1].y2:=589;
{2}  gomb[2].x1:=96;gomb[2].y1:=507;gomb[2].x2:=217;gomb[2].y2:=547;
{3}  gomb[3].x1:=96;gomb[3].y1:=549;gomb[3].x2:=216;gomb[3].y2:=589;
{4}  gomb[4].x1:=219;gomb[4].y1:=508;gomb[4].x2:=299;gomb[4].y2:=547;
{5}  gomb[5].x1:=219;gomb[5].y1:=549;gomb[5].x2:=299;gomb[5].y2:=589;
{6}  gomb[6].x1:=301;gomb[6].y1:=508;gomb[6].x2:=422;gomb[6].y2:=547;
{7}  gomb[7].x1:=301;gomb[7].y1:=550;gomb[7].x2:=423;gomb[7].y2:=590;
{8}  gomb[8].x1:=424;gomb[8].y1:=508;gomb[8].x2:=545;gomb[8].y2:=549;
{9}  gomb[9].x1:=424;gomb[9].y1:=550;gomb[9].x2:=546;gomb[9].y2:=590;
{10} gomb[10].x1:=547;gomb[10].y1:=507;gomb[10].x2:=643;gomb[10].y2:=548;
{11} gomb[11].x1:=548;gomb[11].y1:=550;gomb[11].x2:=642;gomb[11].y2:=590;
{12} gomb[12].x1:=670;gomb[12].y1:=529;gomb[12].x2:=712;gomb[12].y2:=561;
{13} gomb[13].x1:=714;gomb[13].y1:=530;gomb[13].x2:=757;gomb[13].y2:=562;
{14} gomb[14].x1:=672;gomb[14].y1:=563;gomb[14].x2:=713;gomb[14].y2:=589;
{15} gomb[15].x1:=715;gomb[15].y1:=564;gomb[15].x2:=757;gomb[15].y2:=590;
{16} gomb[16].x1:=759;gomb[16].y1:=504;gomb[16].x2:=792;gomb[16].y2:=589;

sargamenu:=2;
sebesseg:=40;
pilseb:=0;

 //az elemeket inaktvv teszi a kezdeti llapot miatt
 for i:=1 to pontok_szama do begin pont[i].aktiv:=false;
                                pont[i].letezes:=false;end;
 for i:=1 to szakaszok_szama do begin szakasz[i].aktiv:=false;
                                szakasz[i].letezes:=false;end;
 for i:=1 to egyenesek_szama do begin egyenes[i].aktiv:=false;
                                egyenes[i].letezes:=false;end;
 for i:=1 to korok_szama do begin kor[i].aktiv:=false;
                                kor[i].letezes:=false;end;

//az elemek megjelensi adatai


fill_mt;

pont[1].x:=bazispont1x;pont[1].y:=bazispont1y; //a bzispontok alaphelyzete
pont[2].x:=bazispont2x;pont[2].y:=bazispont2y;
pont[3].x:=bazispont3x;pont[3].y:=bazispont3y;




for i:=1 to 5 do m_ltomb[i]:=false;


 for i:=1 to gombokszama do begin
 gomb[i].szurke:=false;
 //gomb[i].megjegyzes:=false;
 end;


 // a sznes 1*1 kpek ltrehozsa
 //ezzel fedi le a httrkp menjeit alfa-kirakssal
 init_vw(kek,2,2,true);
 init_vw(sarga,2,2,true);
 init_vw(szurke,2,2,true);

 rectangle(kek,0,0,1,1,0,0,20);
 rectangle(sarga,0,0,1,1,15,31,0);
 rectangle(szurke,0,0,1,1,10,20,10);


 Window_RegisterClass(WIN_Normal);
 Window_Main_Handle:= Window_CreateClass(ApplicationID,WIN_Normal);
 CheckWMCreate;

 Init_Graph(width,height);

 Load_Fonts('Fonts.fnt');
 Load_sprite('menu.sim','',sprite01);
// load_pcx('sugo.pcx','',sugo);


 Init_VW(Result,width,height,true);
 Init_VW(BackGround,Width,Height,true);

 scalesprite(sprite01,background);
 kill_vw(sprite01);
 init_vw(sprite01,szerkesztx,szerkeszty,true);


  init_vw(ures,2,2,true);

{ ScaleSprite(Sprite01,asztal);

 Kill_VW(Sprite01);}

 settextsize(1);
 cursorvisible(true);

end;








// Felszabadtja a kpek ltal lefoglalt memrit, majd bezrja a grafikus
// mdot.
procedure memoria_felszabaditas;
begin

 Kill_VW(BackGround);
 Kill_VW(Sprite01);
 Kill_VW(result);
 kill_vw(ures);
// kill_vw(sugo);
// kill_vw(gombkeret);

 kill_vw(kek);kill_vw(sarga);kill_vw(szurke);


 Kill_Graph;

 CheckMemory;
 TERMINATE;

end;






// elsttti a kpernyt (ez a program vgn tapasztalhat)
procedure lampale;
var
j:shortint;

begin
for j:=0 downto -31 do begin
                        fenyforras:=j;

                        adjustspritebrightness(result,fenyforras,
                                              (fenyforras shl 1),fenyforras);
                        Flip_DD(Result.VWOffset);  // kirajzol a kpernyore!
                        GETALLMESSAGES;
                        HANDLEMINIMIZED;

                        kesleltet(10);
                        end;
fenyforras:=0;
end;





// felvilgostja a kpernyt (de nem mkdik jl... ezrt nem is hasznlom
// a programban)
procedure lampafel(ablak:virtualwindow);
var
j:shortint;

begin
for j:=-31 to 0 do begin
                        fenyforras:=j;

                        scalesprite(result,ablak);
                        adjustspritebrightness(result,fenyforras,
                                              (fenyforras shl 1),fenyforras);
                        Flip_DD(Result.VWOffset);  // kirajzol a kpernyore!
                        GETALLMESSAGES;
                        HANDLEMINIMIZED;

                        kesleltet(10);
                        end;
fenyforras:=0;
end;








// a program elejn lev intro-t jtssza le
procedure intro;
var
j,iii:longint;
beta,sugar:real;
feher:virtualwindow;

begin
sugar:=11;

{ SIMSON felirat}

kill_vw(background);
load_sprite('sim.sim','',background);
init_vw(feher,20,20,true);

cursorvisible(false);


  iii:=gettickcount;
  repeat

  for j:=0 to 599 do linehorz(result,0,799,j,rgbtocol[31,63,31]);

  beta:=(gettickcount-iii)/600;
  putclippedsprite(result,background, round( 150+sugar*cos(beta) ) ,
                                    round( 175+sugar*sin(beta) ) );

  Flip_DD(Result.VWOffset);  // kirajzol a kpernyore!
      GETALLMESSAGES;
      HANDLEMINIMIZED;

  until (gettickcount-iii>7000) or (m_l) or (not applicationrunning);

//lampale;

{KRZO rsz}
{kill_vw(background);
load_pcx('korzo.pcx','',background);



  for j:=0 to 599 do linehorz(result,0,799,j,rgbtocol[31,63,31]);

  putsprite(result,background, result.breitediv2-background.breitediv2,
            result.hoehediv2-background.hoehediv2);

  Flip_DD(Result.VWOffset);  // kirajzol a kpernyore!
      GETALLMESSAGES;
      HANDLEMINIMIZED;

//  lampafel(background);

  iii:=gettickcount;
  repeat
  egerallapotok;
  GETALLMESSAGES;
  HANDLEMINIMIZED;
  until (gettickcount-iii>4000) or ((m_ltomb[2]=false) and (m_l)) or (not applicationrunning);

}

kill_vw(background);
load_sprite('menu.sim','',background);
kill_vw(result);
init_vw(result,800,600,false);
kill_vw(feher);

{lampale;
lampafel(background);}
cursorvisible(true);

end;











//   FOPROGRAM KEZDETE (eljrsoknak,fggvnyeknek mostantl vge!)
BEGIN


init_simson; //feltlti a "konstans"tmbk rtkeit

intro;



   REPEAT // FOCIKLUS!!!

   egerallapotok;

   if sugob=false then sfirst:=true;

   if not sugob
   then
      begin
      szamolasi_Qeljarasok;
      //probaszoveg_kirakas; //csak ideiglenes!
      elemek_kirajzolasa;
      end
   else
      begin
      if sfirst then begin
                     kill_vw(background);
                     load_sprite('sugo.sim','',background);
                     putsprite(result,background,0,0);
                     end;

      if (not m_ltomb[2]) and (m_l) then sugob:=false;

      sfirst:=false;
      if not sugob then begin
                        kill_vw(background);
                        load_sprite('menu.sim','',background);
                        end;

      end;




   adjustspritebrightness(result,fenyforras,(fenyforras shl 1),fenyforras);
   Flip_DD(Result.VWOffset);  // kirajzol a kpernyore!
    GETALLMESSAGES;
    HANDLEMINIMIZED;




   UNTIL not ApplicationRunning or gombkattint(1); //FOCIKLUS vege!


{kill_vw(background);
load_pcx('sugo.pcx','',background);
save_sprite('sugo.sim',background);

kill_vw(background);
load_pcx('sim.pcx','',background);
save_sprite('sim.sim',background);
}

cursorvisible(false);
lampale;

memoria_felszabaditas; //grafika bezrsa s "memriatisztts"

END.
